<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output method="text" indent="yes" media-type="text/plain" encoding="iso-8859-1" omit-xml-declaration="yes"/>
<xsl:param name="package"/>
<xsl:param name="entitySuffix">Bean</xsl:param>
<xsl:param name="blgSuffix">Local</xsl:param>
<xsl:param name="blgSubPackage">.interfaces.</xsl:param>
<xsl:variable name="destPackage" select="concat($package,'.ejb')"/>
<xsl:variable name="blgPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>
<xsl:template match="/">
 <xsl:apply-templates select="database/table" mode="EntityCMP"/>
</xsl:template>
<xsl:template match="table" mode="EntityCMP">
<xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:variable name="format">d'/'MMMM'/'yyyy</xsl:variable>
<xsl:variable name="formatter" select="java:java.text.SimpleDateFormat.new($format)"/>
<xsl:variable name="date" select="java:java.util.Date.new()"/>
<xsl:variable name="data" select="java:format($formatter, $date)"/>
<xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
<xsl:variable name="beanName" select="java:getBeanName($handler)"/>
<xsl:variable name="file" select="concat($destDirectory,'/',$beanName,$entitySuffix,'.java')"/>
<xsl:if test="normalize-space($isNotNM)">
<xalan:write select="$file">
package <xsl:value-of select="$destPackage"/>;
/**
 * Author: WebLEAF Generator
 * @ejb.bean
 *    type="CMP"
 *    cmp-version="2.x"
 *    name="<xsl:value-of select="$beanName"/>"
 *    local-jndi-name="java:comp/env/ejb/panntapoll/<xsl:value-of select="$beanName"/>LocalHome"
 *    view-type="local"
 *
 * @ejb.data-object
 *    container="true"
 *    setdata="true"
 *    generate="true"
 *
 *
 * @ejb.finder
 *    signature="java.util.Collection findAll()"
 *    result-type-mapping="Local"
 *    method-intf="LocalHome"
 *    query="SELECT OBJECT(o) FROM <xsl:value-of select="$beanName"/> o"
 *
 * @ejb.persistence table-name="<xsl:value-of select="@name"/>"
 * @ejb.transaction type="Required"
 *
 *
 */
 public abstract class <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/> implements javax.ejb.EntityBean
 {

  /**
   * Context set by container
   */
  private javax.ejb.EntityContext _entityContext;

  <!--
   Let's build the setters and getters
  -->
  ///////////////////////////////////////////
  // Setters and getters for local members //
  ///////////////////////////////////////////
  <xsl:apply-templates select="column[not(@name=../foreign-key/reference/@local)]" mode="GetterSetter">
   <xsl:with-param name="handler" select="$handler"/>
  </xsl:apply-templates>

  ///////////////////////////////////////////
  // Relationship getters and setters (N-1)//
  ///////////////////////////////////////////
  <xsl:apply-templates select="column[@name=../foreign-key/reference/@local]" mode="RelationshipN1">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:apply-templates>

  ///////////////////////////////////////////
  // Relationship getters and setters (*-N)//
  ///////////////////////////////////////////
  <xsl:variable name="name" select="@name"/>
  <xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="Relationship1N">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="tableName" select="@name"/>
  </xsl:apply-templates>

<xsl:call-template name="DATA_UTILIY">
 <xsl:with-param name="package" select="$package"/>
 <xsl:with-param name="beanName" select="$beanName"/>
</xsl:call-template>

<xsl:call-template name="DATA_BASED_CREATOR">
 <xsl:with-param name="package" select="$package"/>
 <xsl:with-param name="beanName" select="$beanName"/>
 <xsl:with-param name="handler" select="$handler"/>
</xsl:call-template>

<xsl:call-template name="EJB_ENTITY_SPEC_MANDATORY"/>
 }
</xalan:write>
</xsl:if>
 </xsl:template>

<xsl:template match="column" mode="GetterSetter">
 <xsl:param name="handler"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
  /**
   * @return the <xsl:value-of select="$fieldName"/>
   *
   <xsl:if test="@primaryKey='true'">* @ejb:pk-field
   </xsl:if>* @ejb:interface-method view-type="local"
   * @ejb:persistence column-name="<xsl:value-of select="@name"/>"
   */
  public abstract <xsl:value-of select="$fieldClass"/> get<xsl:value-of select="$compositeFieldName"/>();

  /**
   * Sets the <xsl:value-of select="$fieldName"/>
   *
   * @param <xsl:value-of select="$fieldClass"/> the new <xsl:value-of select="$fieldName"/> value
   */
  public abstract void set<xsl:value-of select="$compositeFieldName"/>(<xsl:value-of select="$fieldClass"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$fieldName"/>);
</xsl:template>

<xsl:template match="column" mode="RelationshipN1">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
 <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
 <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="normalRelatedFieldName" select="java:getNormalName($handler,$relatedFieldName)"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   * This is a bi-directional many-to-one relationship CMR method
   *
   * @return the related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @ejb:interface-method view-type="local"
   *
   * @ejb:relation
   *    name="<xsl:value-of select="$beanName"/>-<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>"
   *    role-name="<xsl:value-of select="$beanName"/>-has-<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>"
   *
   * @resin-ejb:relation
   *    sql-column="<xsl:value-of select="@name"/>"
   *
   * @jboss.relation-mapping style="foreign-key"
   *
   * @jboss.relation
   *    fk-constraint="true"
   *    fk-column="<xsl:value-of select="@name"/>"
   *    related-pk-field="<xsl:value-of select="$normalRelatedFieldName"/>"
   */
  public abstract <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/> get<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>();

  /**
   * Sets the related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @param <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/> the related <xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   *
   * @ejb:interface-method view-type="local"
   */
  public abstract void set<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>(<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>);
</xsl:template>

<xsl:template match="foreign-key" mode="Relationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
  <xsl:when test="normalize-space($isNotNM)">
   <xsl:variable name="compositeTableName" select="java:getCompositeName($handler,../@name)"/>
   <xsl:variable name="normalTableName" select="java:getNormalName($handler,../@name)"/>
   <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
   <xsl:variable name="relatedFieldName" select="java:getNormalName($handler,reference/@foreign)"/>
   <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,reference/@foreign)"/>
   <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   * This is a bi-directional one-to-many relationship CMR method
   *
   * @return a java.util.Collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @ejb:interface-method view-type="local"
   *
   * @ejb:relation
   *    name="<xsl:value-of select="$compositeTableName"/>-<xsl:value-of select="$beanName"/><xsl:value-of select="$differenceFieldName"/>"
   *    role-name="<xsl:value-of select="$beanName"/><xsl:value-of select="$differenceFieldName"/>-has-<xsl:value-of select="$compositeTableName"/>"
   *
   * @jboss.relation-mapping style="foreign-key"
   */
  public abstract java.util.Collection get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>();

  /**
   * Sets a collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @param a collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @ejb:interface-method view-type="local"
   */
  public abstract void set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>(java.util.Collection <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>);
  </xsl:when>
  <xsl:otherwise>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName]/@foreignTable"/>
   <xsl:variable name="compositeTableName" select="java:getCompositeName($handler,$relatedTableName)"/>
   <xsl:variable name="normalTableName" select="java:getNormalName($handler,$relatedTableName)"/>
   <xsl:variable name="relatedFieldName" select="../foreign-key[@foreignTable=$tableName]/reference/@local"/>
   <xsl:variable name="relatedOtherFieldName" select="../foreign-key[@foreignTable=$tableName]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherFieldName" select="java:getNormalName($handler,$relatedOtherFieldName)"/>
   <xsl:variable name="relatedForeignFieldName" select="../foreign-key[@foreignTable!=$tableName]/reference/@local"/>
   <xsl:variable name="relatedOtherForeignFieldName" select="../foreign-key[@foreignTable!=$tableName]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherForeignFieldName" select="java:getNormalName($handler,$relatedOtherForeignFieldName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:if test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:if>
   </xsl:variable>
  /**
   * This is a bi-directional many-to-many relationship CMR method
   *
   * @return a java.util.Collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   * @ejb:interface-method view-type="local"
   *
   * @ejb:relation<xsl:choose>
     <xsl:when test="count(following-sibling::foreign-key[@foreignTable=$relatedTableName]) > 0">
   *    name="<xsl:value-of select="$beanName"/>-<xsl:value-of select="$compositeTableName"/>-<xsl:value-of select="$theSuffix"/>"</xsl:when>
     <xsl:otherwise>
   *    name="<xsl:value-of select="$compositeTableName"/>-<xsl:value-of select="$beanName"/>-<xsl:value-of select="$theSuffix"/>"</xsl:otherwise>
    </xsl:choose>
   *    role-name="<xsl:value-of select="$beanName"/>-has-<xsl:value-of select="$compositeTableName"/>-<xsl:value-of select="$theSuffix"/>"
   *
   * @resin-ejb:relation
   *    sql-column="<xsl:value-of select="$relatedFieldName"/>"
   *    sql-table="<xsl:value-of select="../@name"/>"
   *
   * @jboss.relation-mapping style="relation-table"
   * @jboss.relation-table table-name="<xsl:value-of select="../@name"/>"
   *
   * @jboss.relation
   *    fk-constraint="true"
   *    fk-column="<xsl:value-of select="$relatedFieldName"/>"
   *    related-pk-field="<xsl:value-of select="$normalRelatedOtherFieldName"/>"
   *
   * @jboss.target-relation
   *    fk-constraint="true"
   *    fk-column="<xsl:value-of select="$relatedForeignFieldName"/>"
   *    related-pk-field="<xsl:value-of select="$normalRelatedOtherForeignFieldName"/>"
   *
   */
  public abstract java.util.Collection get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>();

  /**
   * Sets a collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   * @param a collection of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   * @ejb:interface-method view-type="local"
   */
  public abstract void set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>(java.util.Collection <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>);
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template name="checkTableNM">
 <xsl:param name="table" select="."/>
  <xsl:for-each select="$table/column">
    <xsl:choose>
      <xsl:when test="not(@primaryKey='true')">1</xsl:when>
      <xsl:when test="not(@name=../foreign-key/reference/@local)">1</xsl:when>
    </xsl:choose>
  </xsl:for-each>
</xsl:template>

<xsl:template name="DATA_UTILIY">
 <xsl:param name="beanName"/>
 <xsl:param name="package"/>
  //////////////////////////
  // Data utility methods //
  //////////////////////////

  /**
   * @return a data object representing this instance
   *
   * @ejb.interface-method view-type="local"
   */
  public abstract <xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>Data getData();

  /**
   * @param data a data object holding new values
   *
   * @ejb.interface-method view-type="local"
   */
  public abstract void setData( <xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>Data data );

</xsl:template>

<xsl:template name="DATA_BASED_CREATOR">
 <xsl:param name="beanName"/>
 <xsl:param name="package"/>
 <xsl:param name="handler"/>
 <xsl:variable name="pkField" select="column[@primaryKey='true']/@name"/>
 <xsl:variable name="compositePkField" select="java:getCompositeName($handler,$pkField)"/>
  /**
   * Creates an instance based on a data object
   *
   * When the client invokes a create method, the EJB container invokes the ejbCreate method.
   * Typically, an ejbCreate method in an entity bean performs the following tasks:
   * <UL>
   * <LI>Inserts the entity state into the database.</LI>
   * <LI>Initializes the instance variables.</LI>
   * <LI>Returns the primary key.</LI>
   * </UL>
   *
   * @param data the data object used to initialise the new instance
   *<xsl:for-each select="column[@name=../foreign-key/reference/@local and @required='true']">
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
   * @param <xsl:value-of select="$normalRelatedTableName"/> mandatory CMR field</xsl:for-each>
   *
   * @return the primary key of the new instance
   *
   * @ejb.create-method
   */
  public <xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>PK ejbCreate(
                            ,<xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>Data data<xsl:for-each select="column[@name=../foreign-key/reference/@local and @required='true']">
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
                            ,<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/>
   </xsl:for-each>
                           ) throws javax.ejb.CreateException
  {
     // Use XDoclet's GUID generator. Only works for String fields
     // This requires <utilobject includeGUID="true"/> in ejbdoclet.
     set<xsl:value-of select="$compositePkField"/>(<xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>Util.generateGUID(this));
     setData(data);
     // Set mandatory CMR fields, to avoid constraint failures<xsl:for-each select="column[@name=../foreign-key/reference/@local and @required='true']">
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
     set<xsl:value-of select="$compositeRelatedTableName"/>(<xsl:value-of select="$normalRelatedTableName"/>);</xsl:for-each>
     // EJB 2.0 spec says return null for CMP ejbCreate methods.
     return null;
  }

  /**
   * The container invokes this method immediately after it calls ejbCreate.
   *
   * @param data the data object used to initialise the new instance
   */
  public void ejbPostCreate(
                            ,<xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/>Data data<xsl:for-each select="column[@name=../foreign-key/reference/@local and @required='true']">
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
                            ,<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/>
   </xsl:for-each>
                           ) throws javax.ejb.CreateException
  {
  }
</xsl:template>

<xsl:template name="EJB_ENTITY_SPEC_MANDATORY">
  //////////////////////////////////////////////////////////////////
  // Implementation of the javax.ejb.EntityBean interface methods //
  //////////////////////////////////////////////////////////////////

  /**
   * The container invokes setEntityContext just once - when it creates the bean instance.
   */
  public void setEntityContext(javax.ejb.EntityContext entityContext)
  {
    _entityContext = entityContext;
  }

  /**
   * At the end of the life cycle, the container removes the instance from
   * the pool and invokes this method.
   */
  public void unsetEntityContext()
  {
    _entityContext = null;
  }

  /**
   * The container invokes this method to instruct the instance to synchronize its
   * state by loading it state from the underlying database.
   */
  public void ejbLoad()
  {
  }

  /**
   * The container invokes this method when the instance is taken out of the pool of
   * available instances to become associated with a specific EJB object.
   */
  public void ejbActivate()
  {
  }

  /**
   * The container invokes this method on an instance before the instance becomes
   * disassociated with a specific EJB object.
   */
  public void ejbPassivate()
  {
  }

  /**
   * The container invokes this method before it removes the EJB object that is
   * currently associated with the instance.
   */
  public void ejbRemove() throws javax.ejb.RemoveException
  {
  }

  /**
   * The container invokes this method to instruct the instance to synchronize its
   * state by storing it to the underlying database.
   */
  public void ejbStore()
  {
  }
 </xsl:template>

</xsl:stylesheet>