<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output  omit-xml-declaration="yes" method="text" indent="yes" media-type="text/plain" encoding="iso-8859-1" doctype-system="http://hibernate.sourceforge.net/hibernate-configuration-2.0.dtd" doctype-public="-//Hibernate/Hibernate Configuration DTD 2.0//EN"/>
<xsl:param name="package"/>
<xsl:param name="configFileName">hibernate.cfg.xml</xsl:param>
<xsl:param name="entitySuffix">Bear</xsl:param>
<xsl:param name="blgSuffix">Bear</xsl:param>
<xsl:param name="blgSubPackage">.blg.</xsl:param>
<xsl:variable name="destPackage" select="concat($package,'.blg')"/>
<xsl:variable name="blgPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>
<xsl:template match="/">
 <xsl:apply-templates select="database/table" mode="HibernateBean"/>
</xsl:template>
<xsl:template match="table" mode="HibernateBean">
<xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:variable name="format">d'/'MMMM'/'yyyy</xsl:variable>
<xsl:variable name="formatter" select="java:java.text.SimpleDateFormat.new($format)"/>
<xsl:variable name="date" select="java:java.util.Date.new()"/>
<xsl:variable name="data" select="java:format($formatter, $date)"/>
<xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
<xsl:variable name="beanName" select="java:getBeanName($handler)"/>
<xsl:variable name="file" select="concat($destDirectory,'/',$beanName,$entitySuffix,'.java')"/>
<xsl:if test="normalize-space($isNotNM) and (not($table_pref) or starts-with(@name,$table_pref))">
<xalan:write select="$file">
package <xsl:value-of select="$destPackage"/>;
/**
 * Author: WebLEAF Generator
 * @hibernate.class
 *  table="<xsl:value-of select="@name"/>"
 *  dynamic-update="true"
 *
 */
 public class <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>
 {
  <!--
   Declare member variables
   -->
  ///////////////////
  // Local members //
  ///////////////////
  <xsl:apply-templates select="column[not(@name=../foreign-key/reference/@local)]" mode="DeclareGetterSetter">
   <xsl:with-param name="handler" select="$handler"/>
  </xsl:apply-templates>

  ////////////////////////////////
  // Relationship members (N-1) //
  ////////////////////////////////
  <xsl:apply-templates select="column[@name=../foreign-key/reference/@local]" mode="DeclareRelationshipN1">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:apply-templates>
  <xsl:variable name="name" select="@name"/>

  ////////////////////////////////
  // Relationship members (*-N) //
  ////////////////////////////////
  <xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareRelationship1N">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="tableName" select="@name"/>
  </xsl:apply-templates>

  <!--
   Let's build the creator
  -->
  <xsl:call-template name="DATA_BASED_CREATOR">
   <xsl:with-param name="package" select="$package"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="handler" select="$handler"/>
  </xsl:call-template>

  <!--
   Let's build the setters and getters
  -->
  ///////////////////////////////////////////
  // Setters and getters for local members //
  ///////////////////////////////////////////
  <xsl:apply-templates select="column[not(@name=../foreign-key/reference/@local)]" mode="GetterSetter">
   <xsl:with-param name="handler" select="$handler"/>
  </xsl:apply-templates>

  ///////////////////////////////////////////
  // Relationship getters and setters (N-1)//
  ///////////////////////////////////////////
  <xsl:apply-templates select="column[@name=../foreign-key/reference/@local]" mode="RelationshipN1">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:apply-templates>

  ///////////////////////////////////////////
  // Relationship getters and setters (*-N)//
  ///////////////////////////////////////////
  <xsl:variable name="name" select="@name"/>
  <xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="Relationship1N">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="tableName" select="@name"/>
  </xsl:apply-templates>

  <xsl:call-template name="EQUALITY">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="tableName" select="@name"/>
  </xsl:call-template>
 }
</xalan:write>
</xsl:if>
</xsl:template>

<xsl:template match="column" mode="GetterSetter">
 <xsl:param name="handler"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
  /**
   * @return the <xsl:value-of select="$fieldName"/>
   *
   <xsl:choose>
   <xsl:when test="@primaryKey='true'">* @hibernate.id
   *  unsaved-value="null"
   *  generator-class="assigned"
   </xsl:when>
   <xsl:otherwise>* @hibernate.property
   <xsl:if test="(@required='true' and not(@default))">*  not-null="true"
   </xsl:if>
   <xsl:if test="$fieldClass='byte[]'">*  type="net.sf.hibernate.type.BlobType"
   </xsl:if>
   <xsl:if test="(@required='true' and @default)">*  insert="false"
   </xsl:if></xsl:otherwise>
   </xsl:choose>*  column="<xsl:value-of select="@name"/>"
   */
  public <xsl:value-of select="$fieldClass"/> get<xsl:value-of select="$compositeFieldName"/>()
  {
    return <xsl:value-of select="$fieldName"/>;
  }

  /**
   * Sets the <xsl:value-of select="$fieldName"/>
   *
   * @param <xsl:value-of select="$fieldClass"/> the new <xsl:value-of select="$fieldName"/> value
   */
  public void set<xsl:value-of select="$compositeFieldName"/>(<xsl:value-of select="$fieldClass"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$fieldName"/>)
  {
   this.<xsl:value-of select="$fieldName"/>=<xsl:value-of select="$fieldName"/>;
  }
</xsl:template>

<xsl:template match="column" mode="DeclareGetterSetter">
 <xsl:param name="handler"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
  /**
   *
   */
  <xsl:value-of select="$fieldClass"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$fieldName"/>;
</xsl:template>

<xsl:template match="column" mode="RelationshipN1">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="compositeFieldName" select="concat(java:getCompositeName($handler,@name),$blgSuffix)"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
 <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
 <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="normalRelatedFieldName" select="java:getNormalName($handler,$relatedFieldName)"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   * This is a bi-directional many-to-one relationship HBMR method
   *
   * @return the related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   *  outer-join="true"
   *
   * @hibernate.many-to-one
   *  cascade="save-update"
   *  column="<xsl:value-of select="@name"/>"
   <xsl:if test="(@required='true' and not(@default))">*  not-null="true"
   </xsl:if>* // hibernate.cache usage="read-write"
   *
   *    fk-column="<xsl:value-of select="@name"/>"
   *    related-pk-field="<xsl:value-of select="$normalRelatedFieldName"/>"
   */
  public <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/> get<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>()
  {
    return <xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>;
  }

  /**
   * Sets the related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @param <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/> the related <xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   *
   */
  public void set<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>(<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>)
  {
   this.<xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>=<xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>;
  }
</xsl:template>

<xsl:template match="column" mode="DeclareRelationshipN1">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
 <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
 <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
 <xsl:variable name="normalRelatedFieldName" select="java:getNormalName($handler,$relatedFieldName)"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   *
   */
  <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>;
</xsl:template>

<xsl:template match="foreign-key" mode="Relationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
  <xsl:when test="normalize-space($isNotNM)">
   <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
   <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,../@name),$blgSuffix)"/>
   <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
   <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
   <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
   <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   * This is a bi-directional one-to-many relationship HBMR method
   *
   * @hibernate.set
   *  lazy="true"
   *  inverse="true"
   *  cascade="save-update"
   * //hibernate.cache usage="read-write"
   * @hibernate.collection-key
   *  column="<xsl:value-of select="reference/@local"/>"
   * @hibernate.collection-one-to-many
   *  class="<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>"
   *
   * @return a java.util.Set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   */
  public java.util.Set get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>()
  {
    return <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>;
  }

  /**
   * Sets a set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   * @param a set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$differenceFieldName"/>
   *
   */
  public void set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>(java.util.Set <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>)
  {
   this.<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>=<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>;
  }
  </xsl:when>
  <xsl:otherwise>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
   <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
   <xsl:variable name="relatedFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@local"/>
   <xsl:variable name="relatedOtherFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherFieldName" select="java:getNormalName($handler,$relatedOtherFieldName)"/>
   <xsl:variable name="relatedForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@local"/>
   <xsl:variable name="relatedOtherForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherForeignFieldName" select="java:getNormalName($handler,$relatedOtherForeignFieldName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
  /**
   * This is a bi-directional many-to-many relationship HBMR method
   *
   * @return a java.util.Set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   * @hibernate.set
   *  lazy="true"
   *  table="<xsl:value-of select="../@name"/>"
   *  cascade="save-update"
   *  order-by="<xsl:value-of select="$relatedFieldName"/>"
   * @hibernate.collection-key
   *  column="<xsl:value-of select="$relatedFieldName"/>"
   * @hibernate.collection-many-to-many
   *  column="<xsl:value-of select="$relatedForeignFieldName"/>"
   *  class="<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>"
   */
  public java.util.Set get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>()
  {
   return <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>;
  }

  /**
   * Sets a set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   * @param a set of related <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$theSuffix"/>
   *
   */
  public void set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>(java.util.Set <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>)
  {
   this.<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>=<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>;
  }
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="foreign-key" mode="DeclareRelationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
  <xsl:when test="normalize-space($isNotNM)">
   <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
   <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,../@name),$blgSuffix)"/>
   <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
   <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
   <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
   <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  /**
   *
   */
  java.util.Set <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$differenceFieldName"/>;
  </xsl:when>
  <xsl:otherwise>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
   <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
   <xsl:variable name="relatedFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@local"/>
   <xsl:variable name="relatedOtherFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherFieldName" select="java:getNormalName($handler,$relatedOtherFieldName)"/>
   <xsl:variable name="relatedForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@local"/>
   <xsl:variable name="relatedOtherForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherForeignFieldName" select="java:getNormalName($handler,$relatedOtherForeignFieldName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
  /**
   *
   */
  java.util.Set <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>;
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template name="DATA_BASED_CREATOR">
 <xsl:param name="beanName"/>
 <xsl:param name="package"/>
 <xsl:param name="handler"/>
 <xsl:variable name="pkField" select="column[@primaryKey='true']/@name"/>
 <xsl:variable name="compositePkField" select="java:getCompositeName($handler,$pkField)"/>
  /**
   * Creates an instance using the default constructor
   */
  public <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>()
  {
  }

  /**
   * Creates an instance based on the mandatory data supplied
   *<xsl:for-each select="column[not(@name=../foreign-key/reference/@local) and (@required='true' and not(@default)) and not(@primaryKey='true')]">
     <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="normalFieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
   * @param <xsl:value-of select="$normalFieldName"/> mandatory field</xsl:for-each>
   *<xsl:for-each select="column[@name=../foreign-key/reference/@local and (@required='true' and not(@default))]">
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
   * @param <xsl:value-of select="$normalRelatedTableName"/> mandatory HBMR field</xsl:for-each>
   */
  public <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>(
                            Object baseObject<xsl:for-each select="column[not(@name=../foreign-key/reference/@local) and (@required='true' and not(@default)) and not(@primaryKey='true')]">
     <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="normalFieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
                            ,<xsl:value-of select="$fieldClass"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalFieldName"/>
   </xsl:for-each>
    <!-- Mandatory HBMR fields -->
    <xsl:for-each select="column[@name=../foreign-key/reference/@local and (@required='true' and not(@default))]">
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
   <xsl:variable name="relatedFieldName" select="../foreign-key/reference[@local=$name]/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
                            ,<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   </xsl:for-each>
                           )
  {
     // Use WebLeaf PK 32bit generator
     String tempPK = org.leaf.util.PKGen.generateGUID(baseObject);
     set<xsl:value-of select="$compositePkField"/>(tempPK);
     // Set mandatory fields, to avoid constraint failures<xsl:for-each select="column[not(@name=../foreign-key/reference/@local) and (@required='true' and not(@default)) and not(@primaryKey='true')]">
     <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="normalFieldName" select="java:getNormalName($handler,@name)"/>
     <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
     this.<xsl:value-of select="$normalFieldName"/> = <xsl:value-of select="$normalFieldName"/>;</xsl:for-each>
     // Set mandatory HBMR fields, to avoid constraint failures<xsl:for-each select="column[@name=../foreign-key/reference/@local and (@required='true' and not(@default))]">
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key/reference[@local=$name]/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     set<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>(<xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>);</xsl:for-each>
  }
</xsl:template>

<xsl:template name="EQUALITY">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,column[@primaryKey='true']/@name)"/>
  /**
   * Creates a default implementation of equals, using the Primary Key
   */
  public boolean equals(Object obj)
  {
   boolean result = false;
    if (<xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>.class.isInstance(obj))
    {
     <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/> temp<xsl:value-of select="$entitySuffix"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>) obj;
     if(this.get<xsl:value-of select="$compositeFieldName"/>()!=null<xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
         temp<xsl:value-of select="$entitySuffix"/>.get<xsl:value-of select="$compositeFieldName"/>()!=null)
     {
      result = this.get<xsl:value-of select="$compositeFieldName"/>().equals(temp<xsl:value-of select="$entitySuffix"/>.get<xsl:value-of select="$compositeFieldName"/>());
     }
    }
    return result;
  }

  /**
   * Creates a default implementation of hascode, using the Primary Key
   */
  public int hashCode()
  {
     if(this.get<xsl:value-of select="$compositeFieldName"/>()!=null)
     {
      return(this.get<xsl:value-of select="$compositeFieldName"/>().hashCode());
     }
     else
     {
      return super.hashCode();
     }
  }
 </xsl:template>
</xsl:stylesheet>