<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output  omit-xml-declaration="no" method="xml" indent="yes" media-type="text/plain" encoding="iso-8859-1" doctype-system="http://hibernate.sourceforge.net/hibernate-configuration-3.0.dtd" doctype-public="-//Hibernate/Hibernate Configuration DTD //EN"/>
<xsl:param name="package"/>
<xsl:param name="configFileName">hibernate.cfg.xml</xsl:param>
<xsl:param name="entitySuffix">Bear</xsl:param>
<xsl:param name="blgSuffix">Bear</xsl:param>
<xsl:param name="blgSubPackage">.blg.</xsl:param>
<xsl:variable name="destPackage" select="concat($package,'.blg')"/>
<xsl:variable name="blgPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>
<xsl:template match="/">
 <xalan:write select="$configFileName">
  <hibernate-configuration><xsl:text disable-output-escaping="yes">
  &lt;!-- a SessionFactory instance listed as /jndi/name --&gt;</xsl:text>
  <session-factory><xsl:text disable-output-escaping="yes">
  &lt;!-- mapping files --&gt;</xsl:text>
  <xsl:apply-templates select="database/table" mode="HibernateMappings"/>
  </session-factory>
  </hibernate-configuration>
 </xalan:write>
</xsl:template>
<xsl:template match="table" mode="HibernateMappings">
  <xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
  <xsl:variable name="beanName" select="java:getBeanName($handler)"/>
  <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:if test="normalize-space($isNotNM) and (not($table_pref) or starts-with(@name,$table_pref))">
      <mapping resource="{$destDirectory}/{$beanName}{$entitySuffix}.hbm.xml"/>
  </xsl:if>
</xsl:template>
</xsl:stylesheet>