<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output  omit-xml-declaration="yes" method="text" indent="yes" media-type="text/plain" encoding="iso-8859-1"/>
<xsl:param name="package"/>
<xsl:param name="entitySuffix">Management</xsl:param>
<xsl:param name="bearUtilsSuffix">BearUtils</xsl:param>
<xsl:param name="blgSuffix">Bear</xsl:param>
<xsl:param name="blgSetSuffix">Bears</xsl:param>
<xsl:param name="blgSubPackage">.blg.</xsl:param>
<xsl:param name="commonSubPackage">.common.</xsl:param>
<xsl:param name="hintsURL">../GenerationHintsManagement.xml</xsl:param>
<xsl:variable name="destPackage" select="concat($package,'.session')"/>
<xsl:variable name="blgPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="commonPackage" select="concat($package,$commonSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>

<xsl:template match="/">
  <xsl:apply-templates select="database/table" mode="HibernateBean"/>
</xsl:template>

<xsl:template match="table" mode="HibernateBean">
<xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:variable name="format">d'/'MMMM'/'yyyy</xsl:variable>
<xsl:variable name="formatter" select="java:java.text.SimpleDateFormat.new($format)"/>
<xsl:variable name="date" select="java:java.util.Date.new()"/>
<xsl:variable name="data" select="java:format($formatter, $date)"/>
<xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
<xsl:variable name="tableName" select="@name"/>
<xsl:variable name="beanName" select="java:getBeanName($handler)"/>
<xsl:variable name="file" select="concat($destDirectory,'/',$beanName,$entitySuffix,'.java')"/>
<xsl:variable name="hints" select="document($hintsURL)/GENERATION_HINTS_LIST/ENTITY[@Table=$tableName]"/>
<xsl:variable name="tablesHints" select="document($hintsURL)/GENERATION_HINTS_LIST/ENTITY"/>
<xsl:if test="normalize-space($isNotNM) and $hints/HINT[@Name='GenerateManagement' and @Value='true']">
<xalan:write select="$file">
package <xsl:value-of select="$destPackage"/>;

import org.apache.ecs.xml.XML;
import org.leaf.xml.DefaultXMLSource;
import org.leaf.util.AbstractManagementSBear;
import org.leaf.util.AbstractManagementSBear.*;

import java.util.List;
import java.util.Map;

import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;
import net.sf.hibernate.Query;
import net.sf.hibernate.type.Type;


import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>;
import <xsl:value-of select="$commonPackage"/><xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>;

<xsl:variable name="name" select="@name"/>

<xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareImportRelationship1N">
 <xsl:with-param name="handler" select="$handler"/>
 <xsl:with-param name="beanName" select="$beanName"/>
 <xsl:with-param name="tableName" select="@name"/>
</xsl:apply-templates>

<xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareImportUtilsRelationship1N">
 <xsl:with-param name="handler" select="$handler"/>
 <xsl:with-param name="beanName" select="$beanName"/>
 <xsl:with-param name="tableName" select="@name"/>
</xsl:apply-templates>

/**
 * Author: WebLEAF Generator
 * Management class for <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>
 */
 public class <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>
 {
  ///////////////////////////////////////
  ////////////// CONSTANTS //////////////
  ///////////////////////////////////////
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_PARAMS_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Parameters_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_LIST_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.List_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_ADD_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Add_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_REM_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Remove_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_UPD_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Update_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_FINDOBJECT_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Find_Object_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.References_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_NOT_EMPTY_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.References_Not_Empty_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Unique_Error";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_PARAMS_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.Unique_Parameters_Error";


  ///////////////////////////////////////
  //////////// END CONSTANTS ////////////
  ///////////////////////////////////////


  <xsl:variable name="name" select="@name"/>


  ///////////////////
  //  Unique Element/s  //
  ///////////////////
  <xsl:call-template name="UNI_ELEMENT">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  ///////////////////
  // List Elements //
  ///////////////////
  <xsl:call-template name="LIST_ELEMENTS">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:call-template>

  /////////////////////////
  // List Elements FILTERED //
  /////////////////////////
  <xsl:call-template name="LIST_ELEMENTS_FILTERED">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:call-template>

  ////////////////////////
  // Select one Element //
  ////////////////////////
  <xsl:call-template name="SELECT_ONE">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:call-template>


  ///////////////////
  //  Add Element  //
  ///////////////////
  <xsl:call-template name="ADD_ELEMENT">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>


  //////////////////////
  //  Remove Element  //
  //////////////////////
  <xsl:call-template name="REM_ELEMENT">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
   <xsl:with-param name="tablesHints" select="$tablesHints"/>
  </xsl:call-template>


  //////////////////////
  //  Update Element  //
  //////////////////////
  <xsl:call-template name="UPD_ELEMENT">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

   /**************************************************************************
    * Business logic methods
    **************************************************************************/

   /**
    * Constructor
    */
    public <xsl:value-of select="$beanName"/>Management() {
    }



  //////////////////////
  //  SHOWALL         //
  //////////////////////
  <xsl:call-template name="SHOW_ALL_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  //////////////////////
  //  SHOWFILTERED       //
  //////////////////////
  <xsl:call-template name="SHOW_FILTERED_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  //////////////////////
  //  SHOW_ELEMENT       //
  //////////////////////
  <xsl:call-template name="SHOW_ELEMENT_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  //////////////////////
  // ADD              //
  //////////////////////
  <xsl:call-template name="ADD_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  //////////////////////
  // REMOVE           //
  //////////////////////
  <xsl:call-template name="REM_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>

  //////////////////////
  // Update  - UPDATE //
  //////////////////////
  <xsl:call-template name="UPD_FUNCTION">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="table" select="."/>
  </xsl:call-template>
 }
</xalan:write>
</xsl:if>
</xsl:template>



<xsl:template match="column" mode="DeclareParameterConstants">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,@name)"/>_PARAM = "<xsl:value-of select="java:getLowerCase($handler,@name)"/>";
  <xsl:if test="@primaryKey!='true' and @required='true' and not(@default)">
   <xsl:variable name="columnName" select="java:getFieldName($handler,@name)"/>
   <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,$columnName)"/>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_NO_<xsl:value-of select="java:getFieldName($handler,@name)"/>_CREATION_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.<xsl:value-of select="$columnNormalName"/>_Vacio";
  </xsl:if>
  <xsl:variable name="columnName" select="@name"/>
  <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
  <xsl:if test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format'] or $fieldClass!='java.lang.String'">
   <xsl:variable name="columnName" select="java:getFieldName($handler,@name)"/>
   <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,$columnName)"/>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,@name)"/>_BAD_FORMAT_CREATION_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.<xsl:value-of select="$columnNormalName"/>_Formato_Incorrecto";
  </xsl:if>
</xsl:template>


<xsl:template match="foreign-key" mode="DeclareRelationship1NConstants">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
 <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
 <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][column/@primaryKey!='true'])"/>
 <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
 <xsl:variable name="theSuffix">
  <xsl:choose>
    <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
    <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
  </xsl:choose>
 </xsl:variable>
 <xsl:variable name="concatSuffix">
  <xsl:choose>
    <xsl:when test="$theSuffix!=''">_<xsl:value-of select="$theSuffix"/></xsl:when>
  </xsl:choose>
 </xsl:variable>
 <xsl:choose>
 <xsl:when test="normalize-space($isNotNM)">
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,reference/@foreign)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,reference/@local,$compositeRelatedFieldName)"
/>
public static final String <xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,../@name)"/>_PARAM = "<xsl:value-of select="java:getLowerCase($handler,reference/@local)"/>";
 </xsl:when>
 <xsl:otherwise>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
public static final String <xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="java:getUpperCase($handler,$concatSuffix)"/>_PARAM =
      "fk_<xsl:value-of select="java:getLowerCase($handler,java:getEntityName($handler))"/>_<xsl:value-of select="java:getLowerCase($handler,java:getEntityName($handler,$relatedTableName))"/><xsl:value-of select="java:getLowerCase($handler,$concatSuffix)"/>";
 </xsl:otherwise>
</xsl:choose>
</xsl:template>





<xsl:template name="LIST_ELEMENTS">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**************************************************************************
  * List "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
 /**
   * Returns the XML List representing every <xsl:value-of select="$lowerName"/>
   *
   * @mainXML adds the XML List representing every <xsl:value-of select="$lowerName"/>
   * @errorListXML returns the possible errors
   */
   public static HBAction listAll<xsl:value-of select="$name"/>Action = new HBAction() {
        public void perform(Map paramMap, Session theSession, XML mainXML,
                XML errorListXML)
   {

       try {
                List the<xsl:value-of select="$name"/>List = theSession
                        .find("from <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> t ");
                java.util.Iterator i = the<xsl:value-of select="$name"/>List.iterator();
                while (i.hasNext())
                {
                    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) i.next();
                    mainXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>));
                }
           } catch (HibernateException e) {
                errorListXML.addElement(DefaultXMLSource.getErrorXML(
                        <xsl:value-of select="java:getEntityName($handler)"/>_LIST_ERROR, e));
           }
        }
    };
</xsl:template>



<xsl:template name="LIST_ELEMENTS_FILTERED">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**************************************************************************
  * List "<xsl:value-of select="$lowerName"/>"Filtered Action
  **************************************************************************/
 /**
   * Returns the XML List representing every <xsl:value-of select="$lowerName"/>
   *
   * @mainXML adds the XML List representing every <xsl:value-of select="$lowerName"/>
   * @errorListXML returns the possible errors
   */
   public static HBAction listFiltered<xsl:value-of select="$name"/>Action = new HBAction() {
        public void perform(Map paramMap, Session theSession, XML mainXML,
                XML errorListXML)
   {
     java.util.List theElements = <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.listOf<xsl:value-of select="$name"/>(paramMap,  theSession,  mainXML,      errorListXML, "");
     if (theElements != null){
       for (java.util.Iterator i = theElements.iterator(); i.hasNext();)
       {
         <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) i.next();
         mainXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>));
       }
     }
     else
     {
    errorListXML.addElement(DefaultXMLSource
              .getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_LIST_ERROR, "List null"));
     }

    }
  };
</xsl:template>


<xsl:template name="SELECT_ONE">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**************************************************************************
  * Select one element "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
 /**
   * Returns the XML representing one  <xsl:value-of select="$lowerName"/>
   *
   * @mainXML adds the XML representing one <xsl:value-of select="$lowerName"/>
   * @errorListXML returns the possible errors
   */
   public static HBAction selectOne<xsl:value-of select="$name"/>Action = new HBAction() {
        public void perform(Map paramMap, Session theSession, XML mainXML,
                XML errorListXML)
   {
     String  code<xsl:value-of select="$name"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,./column[@primaryKey='true']/@name)"/>_PARAM);

        if ((code<xsl:value-of select="$name"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (code<xsl:value-of select="$name"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)){
            try {
                    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> theReal<xsl:value-of select="$name"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) theSession.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>.class, code<xsl:value-of select="$name"/>);
              if (theReal<xsl:value-of select="$name"/> != null) {
      mainXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(theReal<xsl:value-of select="$name"/>));
        }
        else {
                        mainXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>
                                .getNo<xsl:value-of select="$name"/>XML(code<xsl:value-of select="$name"/>));
                    }
       } catch (HibernateException e) {
                                errorListXML.addElement(DefaultXMLSource
                                        .getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_FINDOBJECT_ERROR, e));
             }
          }
    }
  };
</xsl:template>



<xsl:template name="UNI_ELEMENT">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 <xsl:variable name="uniques" select="$hints/HINT/UNIQUES" />
 <xsl:if test="$uniques">
 /**************************************************************************
  * UniqueAdd "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
 /**
   * Checks unicity  of element "<xsl:value-of select="$lowerName"/>" on Add into DB
   *
   * @mainXML adds the XML representing every <xsl:value-of select="$lowerName"/> added
   * @errorListXML returns the possible errors
   */

  public static HBAction uniqueAdd<xsl:value-of select="$name"/>Action = new HBAction() {
    public void perform(Map paramMap, Session theSession, XML mainXML, XML errorListXML) {
<xsl:for-each select="$uniques/FIELD" >
<xsl:variable name="theFieldName" select="@name" />
<xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
       String  the<xsl:value-of select="$theCapFieldName"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,$table/column[@name = $theFieldName]/@name)"/>_PARAM);
 </xsl:for-each>

        if (
  <xsl:for-each select="$uniques/FIELD" >
  <xsl:if test="position() != 1"><xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text></xsl:if>
  <xsl:variable name="theFieldName" select="@name" />
  <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
  (the<xsl:value-of select="$theCapFieldName"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (the<xsl:value-of select="$theCapFieldName"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
  </xsl:for-each>
  ){
         try {
        Query theQuery = theSession.createQuery("from <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> as obj where "
        <xsl:for-each select="$uniques/FIELD" >
        <xsl:variable name="theFieldName" select="@name" />
        <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
        <xsl:variable name="columnNormalName" select="java:getNormalName($handler,$theFieldName)"/>
  <xsl:variable name="theElementHB">
  <xsl:choose>
    <xsl:when test="$table/foreign-key[reference/@local = $theFieldName]"><xsl:variable name="fieldName" select="java:getNormalName($handler,$theFieldName)"/><xsl:variable name="relatedTableName" select="$table/foreign-key[reference/@local=$theFieldName]/@foreignTable"/><xsl:variable name="relatedFieldName" select="$table/foreign-key[reference/@local=$theFieldName]/reference/@foreign"/><xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/><xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/><xsl:variable name="normalRelatedFieldName" select="java:getNormalName($handler,$relatedFieldName)"/><xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/><xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/><xsl:variable name="columnNormalNameRelated" select="java:getNormalName($handler,$relatedFieldName)"/><xsl:value-of select="$normalRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>.<xsl:value-of select="$columnNormalNameRelated"/>
    </xsl:when>
    <xsl:otherwise><xsl:value-of select="$columnNormalName"/></xsl:otherwise>
  </xsl:choose>
  </xsl:variable>

        + " <xsl:if test="position() != 1">and</xsl:if> obj.<xsl:value-of select="$theElementHB"/> = :the<xsl:value-of select="$theCapFieldName" />"
        </xsl:for-each>
        );

        String DATE_FORMAT = "dd/MM/yyyy";
            java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(DATE_FORMAT);
        <xsl:for-each select="$uniques/FIELD" >
        <xsl:variable name="theFieldName" select="@name" />
        <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
        <xsl:variable name="tipus" select="$table/column[@name=$theFieldName]/@type"/>



         <xsl:choose>
            <xsl:when test="java:getClassNameFromType($handler,$tipus) = 'java.sql.Date'">
              java.util.Date dateaux<xsl:value-of select="$theCapFieldName"/> = sdf.parse( the<xsl:value-of select="$theCapFieldName"/>);
              java.sql.Date theDate<xsl:value-of select="$theCapFieldName"/>= new java.sql.Date(dateaux<xsl:value-of select="$theCapFieldName"/>.getTime());
              theQuery.setParameter("the<xsl:value-of select="$theCapFieldName" />",theDate<xsl:value-of select="$theCapFieldName"/>);
            </xsl:when>
            <xsl:otherwise>
              theQuery.setParameter("the<xsl:value-of select="$theCapFieldName" />", new <xsl:value-of  select="java:getClassNameFromType($handler,$tipus)"/>(the<xsl:value-of select="$theCapFieldName"/>));
            </xsl:otherwise>
        </xsl:choose>
        </xsl:for-each>

             if (theQuery.list().size() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0) {
             <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>Data(paramMap, errorListXML, null);

      <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>RelatedData(paramMap, errorListXML, the<xsl:value-of select="$name"/>,theSession);

      errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR, "Unique field")
          .addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>) )
          );

             }
          }
          catch (HibernateException he) {
        errorListXML.addElement(DefaultXMLSource.getErrorXML(
        <xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR, he));
         }
         catch (Exception e) {
        errorListXML.addElement(DefaultXMLSource.getErrorXML(
        <xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR, e));
         }
         }
   } };


  /**************************************************************************
  * UniqueUpd "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
 /**
   * Checks unicity  of element "<xsl:value-of select="$lowerName"/>" on Add into DB
   *
   * @mainXML adds the XML representing every <xsl:value-of select="$lowerName"/> added
   * @errorListXML returns the possible errors
   */

  public static HBAction uniqueUpd<xsl:value-of select="$name"/>Action = new HBAction() {
    public void perform(Map paramMap, Session theSession, XML mainXML, XML errorListXML) {
     String  code<xsl:value-of select="$name"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,./column[@primaryKey='true']/@name)"/>_PARAM);
     <xsl:for-each select="$uniques/FIELD" >
<xsl:variable name="theFieldName" select="@name" />
<xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
       String  the<xsl:value-of select="$theCapFieldName"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,$table/column[@name = $theFieldName]/@name)"/>_PARAM);
 </xsl:for-each>

        if ((code<xsl:value-of select="$name"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (code<xsl:value-of select="$name"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
  <xsl:for-each select="$uniques/FIELD" >
  <xsl:variable name="theFieldName" select="@name" />
  <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
  <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text>
  (the<xsl:value-of select="$theCapFieldName"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (the<xsl:value-of select="$theCapFieldName"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
  </xsl:for-each>
  ){
       try {

      String DATE_FORMAT = "dd/MM/yyyy";
        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(DATE_FORMAT);
        Query theQuery = theSession.createQuery("from <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> as obj where obj.<xsl:value-of select="java:getNormalName($handler,./column[@primaryKey='true']/@name)"/> != :IDPrimaryKey "
        <xsl:for-each select="$uniques/FIELD" >
        <xsl:variable name="theFieldName" select="@name" />
        <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
            <xsl:variable name="columnNormalName" select="java:getNormalName($handler,$theFieldName)"/>
        + " and  obj.<xsl:value-of select="$columnNormalName"/> = :the<xsl:value-of select="$theCapFieldName" />"
        </xsl:for-each>
        );
    theQuery.setParameter("IDPrimaryKey", code<xsl:value-of select="$name"/>);
    <xsl:for-each select="$uniques/FIELD" >
      <xsl:variable name="theFieldName" select="@name" />
      <xsl:variable name="theCapFieldName" select="java:getCompositeName($handler,$theFieldName)"/>
      <xsl:variable name="tipus" select="$table/column[@name=$theFieldName]/@type"/>


    <!--theQuery.setParameter("the<xsl:value-of select="$theCapFieldName" />", new <xsl:value-of select="java:getClassNameFromType($handler,$tipus)"/>(the<xsl:value-of select="$theCapFieldName"/>));-->

         <xsl:choose>
            <xsl:when test="java:getClassNameFromType($handler,$tipus) = 'java.sql.Date'">
              java.util.Date dateaux<xsl:value-of select="$theCapFieldName"/> = sdf.parse( the<xsl:value-of select="$theCapFieldName"/>);
              java.sql.Date theDate<xsl:value-of select="$theCapFieldName"/>= new java.sql.Date(dateaux<xsl:value-of select="$theCapFieldName"/>.getTime());
              theQuery.setParameter("the<xsl:value-of select="$theCapFieldName" />",theDate<xsl:value-of select="$theCapFieldName"/>);
            </xsl:when>
            <xsl:otherwise>
              theQuery.setParameter("the<xsl:value-of select="$theCapFieldName" />", new <xsl:value-of  select="java:getClassNameFromType($handler,$tipus)"/>(the<xsl:value-of select="$theCapFieldName"/>));
            </xsl:otherwise>
        </xsl:choose>

    </xsl:for-each>

    if (theQuery.list().size() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0) {

            <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>Data(paramMap, errorListXML, null);

      <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>RelatedData(paramMap, errorListXML, the<xsl:value-of select="$name"/>,theSession);

      errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR, "Unique field")
          .addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>) )
          );



             }
       } catch (Exception e) {
      errorListXML.addElement(DefaultXMLSource.getErrorXML(
        <xsl:value-of select="java:getEntityName($handler)"/>_UNIQUE_ERROR, e));
        }
    }
   } };

   </xsl:if>
</xsl:template>



<xsl:template name="ADD_ELEMENT">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**************************************************************************
  * Add "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
 /**
   * Insert an element "<xsl:value-of select="$lowerName"/>" into DB
   *
   * @mainXML adds the XML representing every <xsl:value-of select="$lowerName"/> added
   * @errorListXML returns the possible errors
   */

  public static HBAction add<xsl:value-of select="$name"/>Action = new HBAction() {
    public void perform(Map paramMap, Session theSession, XML mainXML, XML errorListXML) {
     try {
        //First fill de data by means of params
        <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>Data(paramMap, errorListXML, null);

        <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>RelatedData(paramMap, errorListXML, the<xsl:value-of select="$name"/>,theSession);

        if (!errorListXML.elements().hasMoreElements()) {
           <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> theReal<xsl:value-of select="$name"/> = null;
           try {
               //Not null fields
               theReal<xsl:value-of select="$name"/> = new <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>(this<xsl:for-each select="$table/column[not(@name=$table/foreign-key/reference/@local) and (@required='true' and not(@default)) and not(@primaryKey='true')]">
               <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>, the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeFieldName"/>()</xsl:for-each><xsl:for-each select="$table/column[(@name=$table/foreign-key/reference/@local) and (@required='true' and not(@default)) and not(@primaryKey='true')]"><xsl:variable name="nameCap" select="@name"/>
               <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$nameCap]/@foreignTable"/><xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/><xsl:variable name="normalRelatedTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/><xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>, the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeRelatedTableName"/>()</xsl:for-each>);
               theSession.save(theReal<xsl:value-of select="$name"/>);

         //Optional fields
          <xsl:for-each select="$table/column[not(@name=$table/foreign-key/reference/@local) and (not(@required='true') and not(@default)) and not(@primaryKey='true')]"><xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>theReal<xsl:value-of select="$name"/>.set<xsl:value-of select="$compositeFieldName"/>(the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeFieldName"/>());
         </xsl:for-each>
         // Relational  fields
          <xsl:for-each select="$table/column[(@name=$table/foreign-key/reference/@local) and (not(@required) and  not(@default)) and not(@primaryKey='true')]"><xsl:variable name="field" select="@name"/><xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/><xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$field]/@foreignTable"/> <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/><xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,../foreign-key[reference/@local=$field]/reference/@foreign)"/><xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/><xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>theReal<xsl:value-of select="$name"/>.set<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>(the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>());
          </xsl:for-each>
         //Relationship 1-N and N-M<xsl:for-each select="$table/../table/foreign-key[@foreignTable=$tableName]"><xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable><xsl:choose>
         <xsl:when test="normalize-space($isNotNM)"><xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
    <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
         theReal<xsl:value-of select="$name"/>.set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>(the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>());</xsl:when>
       <xsl:otherwise><xsl:variable name="local" select="reference/@local"/><xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/><xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
         <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
         <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/><xsl:variable name="theSuffix"><xsl:choose>
        <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
        <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when></xsl:choose></xsl:variable>
        theReal<xsl:value-of select="$name"/>.set<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>(the<xsl:value-of select="$name"/>.get<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>());</xsl:otherwise></xsl:choose>
   </xsl:for-each>

         <xsl:if test="($table/column[not(@name=$table/foreign-key/reference/@local) and (not(@required='true') and not(@default)) and not(@primaryKey='true')]) or ($table/column[(@name=$table/foreign-key/reference/@local) and (not(@required) and  not(@default)) and not(@primaryKey='true')])">
               theSession.saveOrUpdate(theReal<xsl:value-of select="$name"/>); </xsl:if>
         theSession.flush();
                    } catch (HibernateException e) {
                       errorListXML.addElement(DefaultXMLSource.getErrorXML(
                        <xsl:value-of select="java:getEntityName($handler)"/>_ADD_ERROR, e));
                    }
                } else {
                       errorListXML.addElement(DefaultXMLSource.getErrorXML(
                        <xsl:value-of select="java:getEntityName($handler)"/>_PARAMS_ERROR, "Error in parameters"));
                }
               if (errorListXML.elements().hasMoreElements()) {
                          mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_CREATED")
                                .addXMLAttribute("Result", "Error").addElement(
                                        <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>)));
               } else {
                        mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_CREATED")
                                .addXMLAttribute("Result", "Performed")
                                .addElement(
                                        <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>)));
               }
            } catch (Exception e) {
                errorListXML.addElement(DefaultXMLSource.getErrorXML(
                        <xsl:value-of select="java:getEntityName($handler)"/>_ADD_ERROR, e));
            }
   } };
</xsl:template>


<xsl:template name="REM_ELEMENT">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:param name="tablesHints"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
  <xsl:variable name="nameCap2" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 <xsl:variable name="pkName" select="java:getNormalName($handler,$table/column[@primaryKey='true']/@name)"/>
 <xsl:variable name="pkCompoName" select="java:getCompositeName($handler,$table/column[@primaryKey='true']/@name)"/>
 /**************************************************************************
  * Remove "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
  /**
   * Remove an element "<xsl:value-of select="$lowerName"/>" into DB
   *
   * @mainXML adds the XML representing every <xsl:value-of select="$lowerName"/> removed
   * @errorListXML returns the possible errors
   */
  public static HBAction rem<xsl:value-of select="$name"/>Action = new HBAction() {
   public void perform(Map paramMap, Session theSession, XML mainXML, XML errorListXML) {
     String  code<xsl:value-of select="$name"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,./column[@primaryKey='true']/@name)"/>_PARAM);
     if ((code<xsl:value-of select="$name"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (code<xsl:value-of select="$name"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)){
        try {
            <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) theSession.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>.class, code<xsl:value-of select="$name"/>);
            if (the<xsl:value-of select="$name"/> != null) {
                mainXML.addElement( new XML("<xsl:value-of select="$upperName"/>_OLD")
                .addElement( <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>) ));
    <xsl:if test="(../table/foreign-key[@foreignTable = $tableName]) ">
      <xsl:for-each select="../table/foreign-key[@foreignTable = $tableName]" >
        <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select="../."/></xsl:call-template></xsl:variable>
        <xsl:variable name="referenceTable" select="../." />
        <xsl:variable name="nomTable" select="$referenceTable/@name"/>

  <xsl:variable name="local" select="reference/@local"/>
  <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
   <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
   <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
   <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
  <xsl:choose>
        <xsl:when test="normalize-space($isNotNM)">
   <xsl:variable name="Rule" select="$tablesHints[@Table = $nomTable]/HINT/TRIGGERS/RULE[@Table = $tableName]" />
        <xsl:variable name="ruleOnDelete" select="$Rule/@OnDelete"/>
        <xsl:variable name="ruleOnUpdate" select="$Rule/@OnUpdate"/>
      //<xsl:value-of select="$tableName"/> in relation with : <xsl:value-of select="$nomTable"/> OnDelete: <xsl:if test="$ruleOnDelete"><xsl:value-of select="$ruleOnDelete"/> </xsl:if><xsl:if test="not($ruleOnDelete)">Restrict</xsl:if>

         <xsl:choose>
             <xsl:when test="$ruleOnDelete = 'Cascade'">
      try
      {
          if (! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$differenceFieldName"/>().isEmpty())
          {
            theSession.delete(
                          "from <xsl:value-of select="java:getCompositeName($handler,$nomTable)"/><xsl:value-of select="$blgSuffix"/><xsl:value-of select="$differenceFieldName"/> the<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/> where the<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/>.<xsl:value-of select="$nameCap2"/><xsl:value-of select="$blgSuffix"/>.<xsl:value-of select="$pkName"/>=?",
                          new Object[] { the<xsl:value-of select="$name"/>.get<xsl:value-of select="$pkCompoName"/>() },
                          new Type[] { Hibernate.STRING });
            the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$differenceFieldName"/>().clear();
            theSession.flush();
          }
      }
      catch (HibernateException hE)
      {
         errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_ERROR, hE));
      }

                 </xsl:when>
                 <xsl:when test="$ruleOnDelete = 'Restrict'">
          if ( ! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/><xsl:value-of select="$blgSetSuffix"/>().isEmpty())
          {
            errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_NOT_EMPTY_ERROR, "FK Name: '<xsl:value-of select="./reference/@foreignKeyName"/>'  Table: '<xsl:value-of select="$nomTable"/>' Field: '<xsl:value-of select="java:getCompositeName($handler,./reference/@local)"/>'"));
          }
                 </xsl:when>
                 <xsl:when test="$ruleOnDelete = 'NoAction'">
                 </xsl:when>
                 <xsl:otherwise>
          if ( ! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$nomTable)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$differenceFieldName"/>().isEmpty())
          {
            errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_NOT_EMPTY_ERROR, "FK Name: '<xsl:value-of select="./reference/@foreignKeyName"/>' Table: '<xsl:value-of select="$nomTable"/>' Field: '<xsl:value-of select="java:getCompositeName($handler,./reference/@local)"/>'"));
          }
                 </xsl:otherwise>
             </xsl:choose>
          </xsl:when>
    <xsl:otherwise><!-- Relations N-M -->
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
 <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>

   <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,$relatedTableName),$blgSuffix)"/>

   <xsl:variable name="relatedFieldName" select="reference/@local"/>
   <xsl:variable name="relatedOtherFieldName" select="reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherFieldName" select="java:getNormalName($handler,$relatedOtherFieldName)"/>

   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>

   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>

   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$relatedFieldName)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,$nomTable)"/></xsl:when>
      </xsl:choose>
   </xsl:variable>

      <xsl:variable name="Rule" select="$tablesHints[@Table = $tableName]/HINT/TRIGGERS/RULE_NM[@Table = $relatedTableName]" />
        <xsl:variable name="ruleOnDelete" select="$Rule/@OnDelete"/>
        <xsl:variable name="ruleOnUpdate" select="$Rule/@OnUpdate"/>

  //Delete <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
  //<xsl:value-of select="$tableName"/> in relation with : <xsl:value-of select="$relatedTableName"/> OnDelete: <xsl:if test="$ruleOnDelete"><xsl:value-of select="$ruleOnDelete"/> </xsl:if><xsl:if test="not($ruleOnDelete)">Restrict</xsl:if>

         <xsl:choose>
             <xsl:when test="$ruleOnDelete = 'Cascade'">
      try
      {
          if (! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$relatedTableName)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$theSuffix"/>().isEmpty())
          {

            the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$relatedTableName)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$theSuffix"/>().clear();
      //TODO: Falta acabar, ara solo borra la relacion A-C, falta borrar la relacion con C??
      // Habria q mirar si hay q recorrer uno a uno los elementos de este Set, que son elementos de C,
      // y poner, de estos C, a null la relacion unica con A
            theSession.flush();
          }
      }
      catch (HibernateException hE)
      {
         errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_ERROR, hE));
      }

                 </xsl:when>
                 <xsl:when test="$ruleOnDelete = 'Restrict'">
          if ( ! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$relatedTableName)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$theSuffix"/>().isEmpty())
          {
            errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_NOT_EMPTY_ERROR, "FK Name: '<xsl:value-of select="./reference/@foreignKeyName"/>'  Table: '<xsl:value-of select="$nomTable"/>' Field: '<xsl:value-of select="java:getCompositeName($handler,./reference/@local)"/>'"));
          }
                 </xsl:when>
                 <xsl:when test="$ruleOnDelete = 'NoAction'">
                 </xsl:when>
                 <xsl:otherwise>
          if ( ! the<xsl:value-of select="$name"/>.get<xsl:value-of select="java:getCompositeName($handler,$relatedTableName)"/><xsl:value-of select="$blgSetSuffix"/><xsl:value-of select="$theSuffix"/>().isEmpty())
          {
            errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REFERENCES_NOT_EMPTY_ERROR, "FK Name: '<xsl:value-of select="./reference/@foreignKeyName"/>' Table: '<xsl:value-of select="$nomTable"/>' Field: '<xsl:value-of select="java:getCompositeName($handler,./reference/@local)"/>'"));
          }
                 </xsl:otherwise>
             </xsl:choose>


    </xsl:otherwise><!-- Relations N-M -->
    </xsl:choose>
      </xsl:for-each>
    </xsl:if>
      if (! errorListXML.elements().hasMoreElements() )
      {
        try{
          theSession.delete(the<xsl:value-of select="$name"/>);
          theSession.flush();
        } catch (HibernateException e) {
          errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_REM_ERROR, e));
        }
      }

      if (!errorListXML.elements().hasMoreElements()) {
                            mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_REMOVED")
                                    .addXMLAttribute("Result", "Performed")
                                    .addElement(
                                            <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(
                                                    the<xsl:value-of select="$name"/>)));
                        } else {
                            mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_REMOVED")
                                    .addXMLAttribute("Result", "Error")
                                    .addElement(
                                            <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>)));
                        }

            } else {
                errorListXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.getNo<xsl:value-of select="$name"/>XML(code<xsl:value-of select="$name"/>));
            }
        } catch (HibernateException e){
            errorListXML.addElement(DefaultXMLSource.getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_FINDOBJECT_ERROR, e));
        }
    } else {
        errorListXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.getNo<xsl:value-of select="$name"/>XML(null));
    }
  } };

</xsl:template>






<xsl:template name="UPD_ELEMENT">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**************************************************************************
  * Update "<xsl:value-of select="$lowerName"/>" Action
  **************************************************************************/
  /**
   * Remove an element "<xsl:value-of select="$lowerName"/>" into DB
   *
   * @mainXML adds the XML representing every <xsl:value-of select="$lowerName"/> removed
   * @errorListXML returns the possible errors
   */
   public static HBAction upd<xsl:value-of select="$name"/>Action = new HBAction() {
        public void perform(Map paramMap, Session theSession, XML mainXML,  XML errorListXML) {
             String  code<xsl:value-of select="$name"/>  = (String) paramMap.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.<xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="java:getFieldName($handler,./column[@primaryKey='true']/@name)"/>_PARAM);

        if ((code<xsl:value-of select="$name"/> != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (code<xsl:value-of select="$name"/>.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)){
                try {
                    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> = null;
                    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> theReal<xsl:value-of select="$name"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) theSession.get(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>.class, code<xsl:value-of select="$name"/>);

            if (theReal<xsl:value-of select="$name"/> != null) {
                        //fill with the params
                        the<xsl:value-of select="$name"/> = <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>Data(paramMap, errorListXML, theReal<xsl:value-of select="$name"/>);
                        <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.fill<xsl:value-of select="$name"/>RelatedData(paramMap, errorListXML, theReal<xsl:value-of select="$name"/>,theSession);
                        if (!errorListXML.elements().hasMoreElements()) {
                            try {
                                theSession.saveOrUpdate(theReal<xsl:value-of select="$name"/>);
                                theSession.flush();
                            } catch (HibernateException e) {
                                errorListXML.addElement(DefaultXMLSource
                                        .getErrorXML(<xsl:value-of select="java:getEntityName($handler)"/>_UPD_ERROR, e));
                            }
                        }

                        if (!errorListXML.elements().hasMoreElements()) {
                            mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_UPDATED")
                                    .addXMLAttribute("Result", "Performed")
                                    .addElement(
                                            <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(
                                                    theReal<xsl:value-of select="$name"/>)));
                        } else {
                            mainXML.addElement(new XML("<xsl:value-of select="$upperName" />_UPDATED")
                                    .addXMLAttribute("Result", "Error")
                                    .addElement(
                                            <xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.get<xsl:value-of select="$name"/>XML(the<xsl:value-of select="$name"/>)));
                        }
                    } else {
                        mainXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>
                                .getNo<xsl:value-of select="$name"/>XML(code<xsl:value-of select="$name"/>));
                    }
                } catch (HibernateException e) {
                    errorListXML.addElement(DefaultXMLSource.getErrorXML(
                            <xsl:value-of select="java:getEntityName($handler)"/>_FINDOBJECT_ERROR, e));
                }
            } else {
                errorListXML.addElement(<xsl:value-of select="$beanName"/><xsl:value-of select="$bearUtilsSuffix"/>.getNo<xsl:value-of select="$name"/>XML(null));
            }
    } };
</xsl:template>


<xsl:template name="SHOW_ALL_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
   /**
    * Returns the list of all the <xsl:value-of select="$upperName"/>
    */
    public String showAll(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_QUERY");
        theXML.addXMLAttribute("Type", "All");
        XML errorListXML = new XML("ERROR_LIST");
        AbstractManagementSBear.executeAction(paramMap, factory, listAll<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>

<xsl:template name="SHOW_FILTERED_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
   /**
    * Returns the list of all the <xsl:value-of select="$upperName"/>
    */
    public String showFiltered(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_QUERY");
        theXML.addXMLAttribute("Type", "Filtered");
        XML errorListXML = new XML("ERROR_LIST");
        AbstractManagementSBear.executeAction(paramMap, factory, listFiltered<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>


<xsl:template name="SHOW_ELEMENT_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
   /**
    * Returns the list of all the <xsl:value-of select="$upperName"/>
    */
    public String selectOne(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_QUERY");
        theXML.addXMLAttribute("Type", "Selected");
        XML errorListXML = new XML("ERROR_LIST");
        AbstractManagementSBear.executeAction(paramMap, factory, selectOne<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>

<xsl:template name="ADD_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**
  * Adds a <xsl:value-of select="$upperName"/>
  */
    public String add<xsl:value-of select="$name"/>(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_ADD");
        XML errorListXML = new XML("ERROR_LIST");
  <xsl:if test="$hints/HINT/UNIQUES">
  AbstractManagementSBear.executeAction(paramMap, factory,
                uniqueAdd<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        } else {
</xsl:if>
        AbstractManagementSBear.executeAction(paramMap, factory, add<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
<xsl:if test="$hints/HINT/UNIQUES">
        }
</xsl:if>
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>

<xsl:template name="REM_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**
  * Removes a <xsl:value-of select="$upperName"/>
  */
    public String rem<xsl:value-of select="$name"/>(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_REM");
        XML errorListXML = new XML("ERROR_LIST");
        AbstractManagementSBear.executeAction(paramMap, factory, rem<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>


<xsl:template name="UPD_FUNCTION">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="table"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="nameCap" select="java:getCompositeName($handler,$name)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 /**
  * Update a <xsl:value-of select="$upperName"/>
  */
    public String upd<xsl:value-of select="$name"/>(Map paramMap, SessionFactory factory) {
        XML theXML = (XML) new XML("<xsl:value-of select="$upperName"/>_UPD");
        XML errorListXML = new XML("ERROR_LIST");
<xsl:if test="$hints/HINT/UNIQUES">
       AbstractManagementSBear.executeAction(paramMap, factory,
                uniqueUpd<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        } else {
</xsl:if>
  AbstractManagementSBear.executeAction(paramMap, factory, upd<xsl:value-of select="$name"/>Action, theXML, errorListXML);
        if (errorListXML.elements().hasMoreElements()) {
            theXML.addElement(errorListXML);
        }
<xsl:if test="$hints/HINT/UNIQUES">
        }
</xsl:if>
        return DefaultXMLSource.getECSFormattedString(theXML.toString());
    }
</xsl:template>


<xsl:template match="column" mode="DeclareImportRelationshipN1">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
 <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"
 />import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/>;
</xsl:template>




<xsl:template match="foreign-key" mode="DeclareImportRelationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
 <xsl:when test="normalize-space($isNotNM)">
 <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
 <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,../@name),$blgSuffix)"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
 <xsl:variable name="relatedFieldName" select="java:getNormalName($handler,reference/@foreign)"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,reference/@foreign)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"
/>import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:when>
 <xsl:otherwise>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
 <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"
/>import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:otherwise>
</xsl:choose>
</xsl:template>


<xsl:template match="foreign-key" mode="DeclareImportUtilsRelationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
<xsl:when test="normalize-space($isNotNM)">
<xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$bearUtilsSuffix)"/>
<xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,../@name),$bearUtilsSuffix)"/>
<xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
<xsl:variable name="relatedFieldName" select="java:getNormalName($handler,reference/@foreign)"/>
<xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,reference/@foreign)"/>
<xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"
/>import <xsl:value-of select="$commonPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:when>
 <xsl:otherwise>
<xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
<xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$bearUtilsSuffix)"
/>import <xsl:value-of select="$commonPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:otherwise>
</xsl:choose>
</xsl:template>





</xsl:stylesheet>