<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output  omit-xml-declaration="yes" method="text" indent="yes" media-type="text/plain" encoding="iso-8859-1"/>
<xsl:param name="package"/>
<xsl:param name="entitySuffix">BearUtils</xsl:param>
<xsl:param name="blgSuffix">Bear</xsl:param>
<xsl:param name="blgSubPackage">.blg.</xsl:param>
<xsl:variable name="destPackage" select="concat($package,'.common')"/>
<xsl:variable name="blgPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>
<xsl:template match="/">
 <xsl:apply-templates select="database/table" mode="HibernateBean"/>
</xsl:template>
<xsl:template match="table" mode="HibernateBean">
<xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:variable name="format">d'/'MMMM'/'yyyy</xsl:variable>
<xsl:variable name="formatter" select="java:java.text.SimpleDateFormat.new($format)"/>
<xsl:variable name="date" select="java:java.util.Date.new()"/>
<xsl:variable name="data" select="java:format($formatter, $date)"/>
<xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
<xsl:variable name="tableName" select="@name"/>
<xsl:variable name="beanName" select="java:getBeanName($handler)"/>
<xsl:variable name="file" select="concat($destDirectory,'/',$beanName,$entitySuffix,'.java')"/>
<xsl:variable name="hints" select="$hintsDOC/GENERATION_HINTS_LIST/ENTITY[@Table=$tableName]"/>
<xsl:if test="normalize-space($isNotNM) and $hints/HINT[@Name='GenerateUtil' and @Value='true'] and (not($table_pref) or starts-with(@name,$table_pref))">
<xalan:write select="$file">
package <xsl:value-of select="$destPackage"/>;

import org.leaf.xml.DefaultXMLSource;
import org.leaf.xml.XMLNode;
import <xsl:value-of select="$blgPackage"/>*;

<xsl:variable name="name" select="@name"/>
<!-- 
<xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareImportRelationship1N">
 <xsl:with-param name="handler" select="$handler"/>
 <xsl:with-param name="beanName" select="$beanName"/>
 <xsl:with-param name="tableName" select="@name"/>
</xsl:apply-templates>
 -->

/**
 * Author: WebLEAF Generator
 * Utility class for <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>
 */
 public class <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>
 {
  <!--
   Declare member variables
   -->
  ///////////////////////////////////////
  ////////////// CONSTANTS //////////////
  ///////////////////////////////////////
  <xsl:apply-templates select="column" mode="DeclareParameterConstants">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
  </xsl:apply-templates>
  <!--
     Problemas con claves foraneas , si hay 2 sobre una misma tabla.
     Se espera un parametro igual q el campo de la otra tabla -->

  <xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareRelationship1NConstants">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="beanName" select="$beanName"/>
   <xsl:with-param name="tableName" select="@name"/>
  </xsl:apply-templates>

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_NON_EMPTY_REMOVAL_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.No_Vacio";

  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_NOT_FOUND_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.No_Encontrado";

 <xsl:for-each select="column[@name=../foreign-key/reference/@local and @required='true' and not(@default)]">
 <!-- Definicion de variables -->
  <xsl:variable name="name" select="@name"/>
  <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
  <xsl:variable name="relatedFieldName" select="../foreign-key/reference[@local=$name]/@foreign"/>
  <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>

 <!-- Final de definicion de variables -->
 public static final String RELATED_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="$differenceFieldName"/>_EMPTY_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.<xsl:value-of select="$compositeRelatedFieldName"/>_Vacio";
 </xsl:for-each>

   /** ********************************** */
  /** Constants parameters of listOf  */
  /** ********************************** */
<xsl:variable name="upperTableName" select="java:getEntityName($handler)"/>
<xsl:variable name="lowerTableName" select="java:getLowerCase($handler,$upperTableName)"/>

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_NUMPAGE = "param_<xsl:value-of select="$lowerTableName"/>_numpage";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_NUM_MAXROWS_VIEWED = "param_<xsl:value-of select="$lowerTableName"/>_num_maxrows_viewed";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_LIST_ORDER = "param_<xsl:value-of select="$lowerTableName"/>_list_order";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_LIST_ORDER_DIR = "param_<xsl:value-of select="$lowerTableName"/>_list_order_dir";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_NUM_MAXROWS_VIEWED = "param_<xsl:value-of select="$lowerTableName"/>_def_num_maxrows_viewed";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_LIST_ORDER = "param_<xsl:value-of select="$lowerTableName"/>_def_list_order";

  public static final String PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_LIST_ORDER_DIR = "param_<xsl:value-of select="$lowerTableName"/>_def_list_order_dir";


  ///////////////////////////////////////
  //////////// END CONSTANTS ////////////
  ///////////////////////////////////////

  /////////////////
  // Comparators //
  /////////////////
  <xsl:apply-templates select="column[not(@name=../foreign-key/reference/@local)]" mode="Comparator">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:apply-templates>
  <xsl:variable name="name" select="@name"/>

  /////////////////
  // XML Getters //
  /////////////////
  <xsl:call-template name="XML_GETTERS">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:call-template>

  //////////////
  // Fillers  //
  //////////////
  <xsl:call-template name="FILL_DATA">
   <xsl:with-param name="handler" select="$handler"/>
   <xsl:with-param name="hints" select="$hints"/>
   <xsl:with-param name="beanName" select="$beanName"/>
  </xsl:call-template>

 }
</xalan:write>
</xsl:if>
 </xsl:template>

<xsl:template match="column" mode="DeclareParameterConstants">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:variable name="fieldName">
  <xsl:choose>
    <xsl:when test="$hints/@CutPreffixesAtAttributes='false'"><xsl:value-of select="java:getFieldName($handler,@name,false)"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="java:getFieldName($handler,@name)"/></xsl:otherwise>
  </xsl:choose>
 </xsl:variable>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="$fieldName"/>_PARAM = "<xsl:value-of select="java:getLowerCase($handler,@name)"/>";
  <xsl:if test="not(@primaryKey='true') and @required='true' and not(@default)">
   <xsl:variable name="columnName" select="$fieldName"/>
   <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,$columnName)"/>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.<xsl:value-of select="$columnNormalName"/>_Vacio";
  </xsl:if>
  <xsl:variable name="columnName" select="@name"/>
  <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
  <xsl:if test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format'] or $fieldClass!='java.lang.String'">
   <xsl:variable name="columnName" select="$fieldName"/>
   <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,$columnName)"/>
  public static final String <xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR = "<xsl:value-of select="java:getEntityNormalName($handler)"/>.<xsl:value-of select="$columnNormalName"/>_Formato_Incorrecto";
  </xsl:if>
</xsl:template>

<xsl:template match="foreign-key" mode="DeclareRelationship1NConstants">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
 <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
 <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
 <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
 <xsl:variable name="theSuffix">
  <xsl:choose>
    <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
    <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
  </xsl:choose>
 </xsl:variable>
 <xsl:variable name="concatSuffix">
  <xsl:choose>
    <xsl:when test="$theSuffix!=''">_<xsl:value-of select="$theSuffix"/></xsl:when>
  </xsl:choose>
 </xsl:variable>
 <xsl:choose>
 <xsl:when test="normalize-space($isNotNM)">
 <xsl:variable name="fieldName" select="java:getNormalName($handler,$local)"/>   <!-- Sito Composite -->
 <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"
/>
public static final String <xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,../@name)"/><xsl:value-of select="$differenceFieldName"/>_PARAM = "<xsl:value-of select="java:getLowerCase($handler,reference/@local)"/>";
 </xsl:when>
 <xsl:otherwise>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,$local)"/>
  <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
public static final String <xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="java:getUpperCase($handler,$concatSuffix)"/>_PARAM =
      "fk_<xsl:value-of select="java:getLowerCase($handler,java:getEntityName($handler))"/>_<xsl:value-of select="java:getLowerCase($handler,java:getEntityName($handler,$relatedTableName))"/><xsl:value-of select="java:getLowerCase($handler,$concatSuffix)"/>";
 </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="column" mode="Comparator">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="columnName" select="@name"/>
 <xsl:if test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Comparator']">
   <xsl:choose>
    <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Comparator' and @Value='Asc']">
      <xsl:apply-templates select="." mode="ComparatorImpl">
       <xsl:with-param name="handler" select="$handler"/>
       <xsl:with-param name="hints" select="$hints"/>
       <xsl:with-param name="beanName" select="$beanName"/>
       <xsl:with-param name="mode">Asc</xsl:with-param>
      </xsl:apply-templates>
    </xsl:when>
    <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Comparator' and @Value='Both']">
      <xsl:apply-templates select="." mode="ComparatorImpl">
       <xsl:with-param name="handler" select="$handler"/>
       <xsl:with-param name="hints" select="$hints"/>
       <xsl:with-param name="beanName" select="$beanName"/>
       <xsl:with-param name="mode">Asc</xsl:with-param>
       <xsl:with-param name="suffix">Asc</xsl:with-param>
      </xsl:apply-templates>
      <xsl:apply-templates select="." mode="ComparatorImpl">
       <xsl:with-param name="handler" select="$handler"/>
       <xsl:with-param name="hints" select="$hints"/>
       <xsl:with-param name="beanName" select="$beanName"/>
       <xsl:with-param name="mode">Desc</xsl:with-param>
       <xsl:with-param name="suffix">Desc</xsl:with-param>
      </xsl:apply-templates>
    </xsl:when>
    <xsl:otherwise>
      <xsl:apply-templates select="." mode="ComparatorImpl">
       <xsl:with-param name="handler" select="$handler"/>
       <xsl:with-param name="hints" select="$hints"/>
       <xsl:with-param name="beanName" select="$beanName"/>
       <xsl:with-param name="mode">Desc</xsl:with-param>
      </xsl:apply-templates>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:if>
</xsl:template>

<xsl:template match="column" mode="ComparatorImpl">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:param name="mode">Desc</xsl:param>
 <xsl:param name="suffix"/>
 <xsl:variable name="columnName" select="@name"/>
 <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
 <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="columnNormalName">
  <xsl:choose>
    <xsl:when test="$hints/@CutPreffixesAtAttributes='false'"><xsl:value-of select="java:getCompositeName($handler,java:getFieldName($handler,$columnName,false))"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="java:getCompositeName($handler,java:getFieldName($handler,$columnName))"/></xsl:otherwise>
  </xsl:choose>
 </xsl:variable>
  <xsl:variable name="columnHints" select="$hints/FIELD[@Column=$columnName]"/>
  <xsl:choose>
   <xsl:when test="$fieldClass='java.lang.String' or $fieldClass='java.lang.Integer' or $fieldClass='java.sql.Date' or $fieldClass='java.sql.Time' or $fieldClass='java.sql.Timestamp' or $fieldClass='java.math.BigInteger' or $fieldClass='java.math.BigDecimal'">
 public static final java.util.Comparator <xsl:value-of select="$lowerName"/>By<xsl:value-of select="$columnNormalName"/>Comparator<xsl:value-of select="$suffix"/> = new java.util.Comparator()
 {
   public int compare(Object arg0, Object arg1)
   {
     <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> a<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg0;
     <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> another<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg1;
     if(!arg0.equals(arg1))
     {
      <xsl:choose>
      <xsl:when test="$columnHints/HINT[@Name='ComparatorIgnoreCase' and @Value='true']">
      int dif = ((String)a<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>()).compareToIgnoreCase((String)another<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>());
      </xsl:when>
      <xsl:otherwise>
      int dif = a<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>().compareTo(another<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>());
      </xsl:otherwise>
      </xsl:choose>
      if (dif != 0)
      {<xsl:choose>
      <xsl:when test="$mode='Asc'">
        return dif;
      </xsl:when>
      <xsl:otherwise>
        return -dif;
      </xsl:otherwise>
     </xsl:choose>
      }
      else
      {
        return 1;
      }
     }
     else
     {
      return 0;
     }
   }
 };
   </xsl:when>
   <xsl:when test="$fieldClass='boolean'">
 public static final java.util.Comparator <xsl:value-of select="$lowerName"/>By<xsl:value-of select="$columnNormalName"/>Comparator<xsl:value-of select="$suffix"/> = new java.util.Comparator()
 {
   public int compare(Object arg0, Object arg1)
   {
     if(!arg0.equals(arg1))
     {
       <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> a<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg0;
       <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> another<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg1;<xsl:choose>
       <xsl:when test="$mode='Asc'">
       int result = -1;
       </xsl:when>
       <xsl:otherwise>
       int result = 1;
       </xsl:otherwise>
       </xsl:choose>if(a<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>())
       {
         return result;
       }
       else
       {
         return -result;
       }
     }
     else
     {
      return 0;
     }
   }
 };
   </xsl:when>
   <xsl:when test="$fieldClass='int' or $fieldClass='byte' or $fieldClass='short' or $fieldClass='long' or $fieldClass='double'">
 public static final java.util.Comparator <xsl:value-of select="$lowerName"/>By<xsl:value-of select="$columnNormalName"/>Comparator<xsl:value-of select="$suffix"/> = new java.util.Comparator()
 {
   public int compare(Object arg0, Object arg1)
   {
     if(!arg0.equals(arg1))
     {
      <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> a<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg0;
      <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> another<xsl:value-of select="java:getEntityNormalName($handler)"/> = (<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>) arg1;
      <xsl:value-of select="$fieldClass"/> dif = a<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>() - another<xsl:value-of select="java:getEntityNormalName($handler)"/>.get<xsl:value-of select="$compositeFieldName"/>();
      if (dif != 0)
      {<xsl:choose>
      <xsl:when test="$mode='Asc'">
        return -dif;
      </xsl:when>
      <xsl:otherwise>
        return dif;
      </xsl:otherwise>
     </xsl:choose>
      }
      else
      {
        return 1;
      }
     }
     else
     {
      return 0;
     }
   }
 };
   </xsl:when>
  </xsl:choose>
</xsl:template>


<xsl:template name="XML_GETTERS">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
 <xsl:if test="column[@name=../foreign-key/reference/@local] or ../table/foreign-key[@foreignTable=$tableName]">
 /**
   * Returns the XMLNode representing one <xsl:value-of select="$lowerName"/>
   *
   * @return the XMLNode representing one <xsl:value-of select="$lowerName"/>
   */
  public static XMLNode get<xsl:value-of select="$name"/>XML(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/>)
  {
    return get<xsl:value-of select="$name"/>XML(<xsl:value-of select="$lowerName"/>
    <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
     <xsl:variable name="columnname" select="@name"/>
     <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$columnname]/@foreignTable"/>
     <xsl:choose>
      <xsl:when test="@required and not($hints/RELATIONSHIP[@TargetTable=$relatedTableName]/HINT[@Name='ShowAlways' and @Value='false'])">
    ,true
      </xsl:when>
     <xsl:otherwise>
    ,false
     </xsl:otherwise>
     </xsl:choose>
    </xsl:for-each>
    <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
    ,false
    </xsl:for-each>
   );
  }
 </xsl:if>

  /**
   * Returns the XMLNode representing one <xsl:value-of select="$lowerName"/> that was not found
   *
   * @return the XMLNode representing one <xsl:value-of select="$lowerName"/> that was not found
   */
  public static XMLNode getNo<xsl:value-of select="$name"/>XML(String codigo)
  {
    XMLNode theXML = DefaultXMLSource.getErrorXMLNode(
        <xsl:value-of select="$beanName"/><xsl:value-of select="$entitySuffix"/>.<xsl:value-of select="$upperName"/>_NOT_FOUND_ERROR,
        "<xsl:value-of select="$name"/> not found");
    if (codigo != null)
    {
      theXML.addElement(new XMLNode("NO_<xsl:value-of select="$upperName"/>").addAttribute(
          "Codigo", codigo));
    }
    else
    {
      theXML.addElement(new XMLNode("NO_<xsl:value-of select="$upperName"/>").addAttribute(
          "Codigo", "null"));
    }
    return theXML;
  }

 <xsl:if test="../table/foreign-key/@foreignTable=$tableName">
 /**
   * Returns the XMLNode representing one <xsl:value-of select="$lowerName"/>
   * and its related entities, if desired
   *
   * @return the XMLNode representing one <xsl:value-of select="$lowerName"/>
   */
  public static XMLNode get<xsl:value-of select="$name"/>XML(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/>
   <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
   <!-- Definicion de variables -->
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="compositeRelatedTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
    <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <!-- Final de definicion de variables -->
    ,boolean show<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   </xsl:for-each>
   <!-- ************************************************************* -->
   <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
   <!-- Definicion de variables -->
   <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
   <xsl:variable name="local" select="reference/@local"/>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
   <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
   <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
   <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
   <!-- Final de definicion de variables -->
   <xsl:choose>
    <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     ,boolean show<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
    </xsl:when>
    <xsl:otherwise>
     ,boolean show<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
    </xsl:otherwise>
   </xsl:choose>
   </xsl:for-each>)
   {
   <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
   <!-- Definicion de variables -->
   <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
   <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
   <xsl:variable name="local" select="reference/@local"/>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
   <!-- Final de definicion de variables -->
     <!-- Definicion de relatedEntityName -->
     <xsl:variable name="relatedEntityName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)">
       <xsl:value-of select="$compositeTableName"/>
      </xsl:when>
      <xsl:otherwise>
         <xsl:value-of select="$normalTableName"/>
      </xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <!-- Definicion de relatedEntityTableName -->
     <xsl:variable name="relatedEntityTableName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)">
       <xsl:value-of select="../@name"/>
      </xsl:when>
      <xsl:otherwise>
       <xsl:variable name="local" select="reference/@local"/>
       <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
         <xsl:value-of select="$relatedTableName"/>
      </xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <xsl:variable name="comparator">
     <xsl:choose>
      <xsl:when test="$hints/RELATIONSHIP[@TargetTable=$relatedEntityTableName]/HINT[@Name='OrderBy']">
     <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,java:getFieldName($handler,$hints/RELATIONSHIP[@TargetTable=$relatedEntityTableName]/HINT[@Name='OrderBy']/@Value))"/>
     <xsl:value-of select="java:getCompositeName($handler,$relatedEntityTableName)"/><xsl:value-of select="$entitySuffix"/>.<xsl:value-of select="java:getLowerCase($handler,$relatedEntityName)"/>By<xsl:value-of select="$columnNormalName"/>Comparator
     </xsl:when>
      <xsl:when test="$hints/RELATIONSHIP[@TargetTable=$relatedEntityTableName]/HINT[@Name='OrderByComparator']">
     <xsl:value-of select="$hints/RELATIONSHIP[@TargetTable=$relatedEntityTableName]/HINT[@Name='OrderByComparator']/@Value"/>
     </xsl:when>
     <xsl:otherwise>
      null
     </xsl:otherwise>
     </xsl:choose>
   </xsl:variable>
   <xsl:choose>
    <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
     <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     java.util.Comparator compare<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/> = <xsl:value-of select="$comparator"/>;
    </xsl:when>
    <xsl:otherwise>
     java.util.Comparator compare<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/> = <xsl:value-of select="$comparator"/>;
    </xsl:otherwise>
   </xsl:choose>
   </xsl:for-each>
    return get<xsl:value-of select="$name"/>XML(<xsl:value-of select="$lowerName"/>
   <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
   <!-- Definicion de variables -->
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="compositeRelatedTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
    <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <!-- Final de definicion de variables -->
    ,show<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   </xsl:for-each>
   <!-- ************************************************************* -->
   <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
   <!-- Definicion de variables -->
   <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
   <xsl:variable name="local" select="reference/@local"/>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
   <!-- Final de definicion de variables -->
   <xsl:choose>
    <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
     <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     ,show<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>, compare<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
    </xsl:when>
    <xsl:otherwise>
     ,show<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>, compare<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
    </xsl:otherwise>
   </xsl:choose>
   </xsl:for-each>);
   }
 </xsl:if>



 /**
   * Returns the XMLNode representing one <xsl:value-of select="$lowerName"/>
   * and its related entities, if desired
   *
   * @return the XMLNode representing one <xsl:value-of select="$lowerName"/>
   */
  public static XMLNode get<xsl:value-of select="$name"/>XML(<xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/>
   <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
   <!-- Definicion de variables -->
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="compositeRelatedTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
    <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <!-- Final de definicion de variables -->
    ,boolean show<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>
   </xsl:for-each>
   <!-- ************************************************************* -->
   <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
   <!-- Definicion de variables -->
   <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
   <xsl:variable name="local" select="reference/@local"/>
   <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
   <!-- Final de definicion de variables -->
   <xsl:choose>
    <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
    <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     ,boolean show<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>, java.util.Comparator compare<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
    </xsl:when>
    <xsl:otherwise>
     ,boolean show<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>, java.util.Comparator compare<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
    </xsl:otherwise>
   </xsl:choose>
   </xsl:for-each>)
  {
    XMLNode <xsl:value-of select="$lowerName"/>XML =
      new XMLNode("<xsl:value-of select="$upperName"/>")
    <xsl:for-each select="column[not(@name=../foreign-key/reference/@local)]">
      <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,java:getFieldName($handler,@name))"/>
      <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
      <xsl:variable name="columnName" select="@name"/>
      <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
      <xsl:if test="not($hints/FIELD[@Column=$columnName]/HINT[@Name='ToXMLNoShow' and @Value='true'])">
      <xsl:choose>
        <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Formatter]">
      .addAttribute("<xsl:value-of select="$columnNormalName"/>"
       ,<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>()
       ,<xsl:value-of select="$hints/FIELD[@Column=$columnName]/HINT/@Formatter"/>)
        </xsl:when>
        <xsl:when test="$fieldClass='java.sql.Clob'">
      .addElement(new XMLNode("<xsl:value-of select="$columnNormalName"/>").addElement(
      <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>()))
        </xsl:when>
        <xsl:otherwise>
      .addAttribute("<xsl:value-of select="$columnNormalName"/>"
       ,<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>())
        </xsl:otherwise>
      </xsl:choose>
      </xsl:if>
    </xsl:for-each>;
   <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
   <!-- Definicion de variables -->
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,java:getFieldName($handler,@name))"/>
    <xsl:variable name="columnName" select="@name"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="compositeRelatedName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedUtilsName" select="concat(java:getCompositeName($handler,$relatedTableName),$entitySuffix)"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key[reference/@local=$name]/reference/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
    <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
   <!-- Final de definicion de variables -->
    if (show<xsl:value-of select="$compositeRelatedName"/><xsl:value-of select="$differenceFieldName"/> <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text><xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>() != null)
    {
      XMLNode tempNode =
        <xsl:value-of select="$compositeRelatedUtilsName"/>.get<xsl:value-of select="$compositeRelatedName"/>XML(<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>()
        <xsl:value-of select="$hints/RELATIONSHIP[@TargetTable=$relatedTableName]/HINT[@Name='showParams']/@Value"/>);
        tempNode.addAttribute("FROM","<xsl:value-of select="$columnNormalName"/>");
      <xsl:value-of select="$lowerName"/>XML.addElement(tempNode);
    }
   </xsl:for-each>
   <xsl:for-each select="../table/foreign-key[@foreignTable=$tableName]">
     <!-- Definicion de variables comunes-->
     <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="local" select="reference/@local"/>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
     <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
     <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
     <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
    <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <xsl:variable name="theSuffix">
      <xsl:choose>
        <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
        <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
      </xsl:choose>
     </xsl:variable>
     <!-- Final de definicion de variables comunes-->
     <!-- Definicion de relatedEntityName -->
     <xsl:variable name="relatedEntityName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)">
       <xsl:value-of select="$compositeTableName"/>
      </xsl:when>
      <xsl:otherwise>
         <xsl:value-of select="$normalTableName"/>
      </xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <!-- Definicion de conditionName -->
     <xsl:variable name="conditionName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)">
       <xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
      </xsl:when>
      <xsl:otherwise>
         <xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
      </xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <!-- Definicion de relatedEntityTableName -->
     <xsl:variable name="relatedEntityTableName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)">
       <xsl:value-of select="../@name"/>
      </xsl:when>
      <xsl:otherwise>
       <xsl:variable name="local" select="reference/@local"/>
       <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
         <xsl:value-of select="$relatedTableName"/>
      </xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <xsl:variable name="lowerRelatedEntityName" select="java:getLowerCase($handler,$relatedEntityName)"/>
     <xsl:variable name="upperRelatedEntityName" select="java:getEntityName($handler,$relatedEntityTableName)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/><!-- Sito  Composite-->
     <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName"     select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <!-- Definicion de methodName -->
     <xsl:variable name="methodName">
     <xsl:choose>
      <xsl:when test="normalize-space($isNotNM)"><xsl:value-of select="java:getCompositeName($handler,$relatedEntityTableName)"/><xsl:value-of select="$blgSuffix"/>s<xsl:value-of select="$differenceFieldName"/></xsl:when>
      <xsl:otherwise><xsl:value-of select="java:getCompositeName($handler,$relatedEntityTableName)"/><xsl:value-of select="$blgSuffix"/>s<xsl:value-of select="$theSuffix"/></xsl:otherwise>
     </xsl:choose>
     </xsl:variable>
     <xsl:variable name="comparator">
       <xsl:choose>
        <xsl:when test="normalize-space($isNotNM)">
         <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
         compare<xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
        </xsl:when>
        <xsl:otherwise>
         compare<xsl:value-of select="$normalTableName"/>s<xsl:value-of select="$theSuffix"/>
        </xsl:otherwise>
       </xsl:choose>
     </xsl:variable>
       if (show<xsl:value-of select="$conditionName"/> <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text><xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$methodName"/>() != null <xsl:text disable-output-escaping="yes"> &amp;&amp; !</xsl:text><xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$methodName"/>().isEmpty())
       {
        XMLNode the<xsl:value-of select="$relatedEntityName"/>sXML =
          new XMLNode("<xsl:value-of select="$upperRelatedEntityName"/>_LIST").addAttribute("Type", "<xsl:value-of select="$differenceFieldName"/>From<xsl:value-of select="$name"/><xsl:value-of select="$theSuffix"/>");
        java.util.Set related<xsl:value-of select="$relatedEntityName"/>s = null;
        if(<xsl:value-of select="$comparator"/>!=null)
        {
          related<xsl:value-of select="$relatedEntityName"/>s = new java.util.TreeSet(<xsl:value-of select="$comparator"/>);
          related<xsl:value-of select="$relatedEntityName"/>s.addAll(<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$methodName"/>());
        }
        else
        {
         related<xsl:value-of select="$relatedEntityName"/>s = <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$methodName"/>();
        }
        for (java.util.Iterator i = related<xsl:value-of select="$relatedEntityName"/>s.iterator(); i.hasNext();)
        {
          the<xsl:value-of select="$relatedEntityName"/>sXML.addElement(
            <xsl:value-of select="java:getCompositeName($handler,$relatedEntityTableName)"/><xsl:value-of select="$entitySuffix"/>.get<xsl:value-of select="$relatedEntityName"/>XML((<xsl:value-of select="java:getCompositeName($handler,$relatedEntityTableName)"/><xsl:value-of select="$blgSuffix"/>) i.next()
            <xsl:value-of select="$hints/RELATIONSHIP[@TargetTable=$relatedEntityTableName]/HINT[@Name='showParams']/@Value"/>));
        }
        <xsl:value-of select="$lowerName"/>XML.addElement(the<xsl:value-of select="$relatedEntityName"/>sXML);
       }
   </xsl:for-each>
    return <xsl:value-of select="$lowerName"/>XML;
  }



   public static java.util.List listOf<xsl:value-of select="$name"/>(java.util.Map paramMap, org.hibernate.Session theSession, XMLNode mainXML,
      XMLNode errorListXML, String where)
  {
    int maxRowsViewed = 0; //The default presents all values
    int numPage = 0;
    int numTotalRows = 0;

    String paramNumPage = (String) paramMap.get(PARAM_<xsl:value-of select="$upperName"/>_NUMPAGE);

    if ((paramNumPage != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (paramNumPage.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
    {
      try
      {
        numPage = Integer.valueOf(paramNumPage).intValue();
      }
      catch (NumberFormatException eN)
      {
        numPage = 0;
      }
    }

    String paramNumMaxRowsViewed = (String) paramMap
        .get(PARAM_<xsl:value-of select="$upperName"/>_NUM_MAXROWS_VIEWED);
    if ((paramNumMaxRowsViewed != null)
        <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (paramNumMaxRowsViewed.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
    {
      try
      {
        maxRowsViewed = Integer.valueOf(paramNumMaxRowsViewed).intValue();
      }
      catch (NumberFormatException eN)
      {
        maxRowsViewed = 0;
      }
    }
    else
    {
       String paramDefNumMaxRowsViewed = (String) paramMap
          .get(PARAM_<xsl:value-of select="$upperName"/>_DEFAULT_NUM_MAXROWS_VIEWED);
      if ((paramDefNumMaxRowsViewed != null)
          <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (paramDefNumMaxRowsViewed.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
      {
        try
        {
          maxRowsViewed = Integer.valueOf(paramDefNumMaxRowsViewed).intValue();
        }
        catch (NumberFormatException eN)
        {
          maxRowsViewed = 0;
        }
      }
    }

    String paramListOrder = (String) paramMap.get(PARAM_<xsl:value-of select="$upperName"/>_LIST_ORDER);
    String orderBy = new String("");
    if ((paramListOrder != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (paramListOrder.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
    {
      orderBy = new String("order by the<xsl:value-of select="$name"/>." + paramListOrder);
    }
    else
    {
        String paramDefListOrder = (String) paramMap.get(PARAM_<xsl:value-of select="$upperName"/>_DEFAULT_LIST_ORDER);
      if ((paramDefListOrder != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text> (paramDefListOrder.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
      {
        orderBy = new String("order by the<xsl:value-of select="$name"/>." + paramDefListOrder);
          paramListOrder = paramDefListOrder;
      }
      else
      {
        paramListOrder = new String("");
        orderBy = new String("order by 2"); //suposam q sempre el primer camp es l identificador
        // ordenam per el segon camp
      }
    }


    String paramListOrderDir = (String) paramMap.get(PARAM_<xsl:value-of select="$upperName"/>_LIST_ORDER_DIR);
    if ((paramListOrderDir != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text>(paramListOrderDir.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
    {//si paramListOrderDir !) null ordre invers
      if (paramListOrderDir.equalsIgnoreCase("ASC"))
      {
        orderBy = orderBy + " asc";
      }
      else
      {
        orderBy = orderBy + " desc";
        paramListOrderDir = new String("DESC");
      }
    }
    else
    {
      String paramDefListOrderDir = (String) paramMap.get(PARAM_<xsl:value-of select="$upperName"/>_DEFAULT_LIST_ORDER_DIR);
      if ((paramDefListOrderDir != null) <xsl:text disable-output-escaping="yes">&amp;&amp;</xsl:text>(paramDefListOrderDir.trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0))
      {
        if (paramDefListOrderDir.equalsIgnoreCase("ASC"))
        {
          orderBy = orderBy + " asc";
          paramListOrderDir = new String("ASC");
        }
        else
        {
          orderBy = orderBy + " desc";
          paramListOrderDir = new String("DESC");
        }
      }
      else{
        paramListOrderDir = new String("ASC");
        orderBy = orderBy + " asc";
        }
    }

    try
    {
      org.hibernate.Query q1 = theSession
          .createQuery("select count(the<xsl:value-of select="$name"/>) from <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> "
              + where);
      java.util.List listNumTotalRows = q1.list();
      if (listNumTotalRows.size() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
      {
        numTotalRows = ((Integer) listNumTotalRows.get(0)).intValue();
      }
      int totalPages = 1;
      if (maxRowsViewed == 0)
      {
        maxRowsViewed = numTotalRows;
        numPage = 0;
      }
      else
      {
    totalPages = numTotalRows / maxRowsViewed;
    if (numTotalRows % maxRowsViewed <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
    {
          totalPages++;
    }
       }


      org.hibernate.Query q = theSession.createQuery("from <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> the<xsl:value-of select="$name"/> " + where
          + " " + orderBy);
      q.setFirstResult(numPage * maxRowsViewed);
      q.setMaxResults(maxRowsViewed);


      mainXML.addAttribute("NumPage", String.valueOf(numPage));
      mainXML.addAttribute("TotalPages", String.valueOf(totalPages));
      mainXML.addAttribute("NumMaxRowsViewed", String.valueOf(maxRowsViewed));
      mainXML.addAttribute("NumMaxRows", String.valueOf(numTotalRows));
      mainXML.addAttribute("ListOrder", paramListOrder);
      mainXML.addAttribute("ListOrderDir", paramListOrderDir);
      return q.list();
    }
    catch (org.hibernate.HibernateException e)
    {
      errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
          "Error retrieving <xsl:value-of select="$name"/> list", e));
          return null;
    }

  }
</xsl:template>

<xsl:template match="column" mode="DeclareImportRelationshipN1">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
 <xsl:variable name="name" select="@name"/>
 <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
 <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"
 />import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/>;
</xsl:template>

<xsl:template match="foreign-key" mode="DeclareImportRelationship1N">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:choose>
 <xsl:when test="normalize-space($isNotNM)">
 <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
 <xsl:variable name="normalTableName" select="concat(java:getNormalName($handler,../@name),$blgSuffix)"/>
 <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
 <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"
/>import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:when>
 <xsl:otherwise>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
 <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"
/>import <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeTableName"/>;
 </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="FILL_DATA">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:param name="beanName"/>
 <xsl:variable name="name" select="java:getEntityNormalName($handler)"/>
 <xsl:variable name="tableName" select="@name"/>
 <xsl:variable name="lowerName" select="java:getLowerCase($handler,$name)"/>
 <xsl:variable name="upperName" select="java:getEntityName($handler)"/>
  /**
  * Fills the data of a dummy <xsl:value-of select="$lowerName"/> with the data coming in the parameters
  * map. It also modifies the values of the original <xsl:value-of select="$lowerName"/>, but the codigo,
  * in case it is passed.
  *
  * @return a dummy <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> filled with the data
  */
  public static <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> fill<xsl:value-of select="$name"/>Data(
    java.util.Map paramMap,
    XMLNode errorListXML,
    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/>Original)
  {
    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/> = new <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/>();
    <xsl:for-each select="column[not(@name=../foreign-key/reference/@local)]">
      <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,java:getFieldName($handler,@name))"/>
      <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
      <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
      <xsl:variable name="fieldName">
       <xsl:choose>
         <xsl:when test="$hints/@CutPreffixesAtAttributes='false'"><xsl:value-of select="java:getFieldName($handler,@name,false)"/></xsl:when>
         <xsl:otherwise><xsl:value-of select="java:getFieldName($handler,@name)"/></xsl:otherwise>
       </xsl:choose>
      </xsl:variable>
      <xsl:if test="$fieldClass='java.lang.String'">
        <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>((String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM));
      </xsl:if>
      <xsl:if test="$fieldClass='java.sql.Clob'">
        String temp<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
        if(temp<xsl:value-of select="$compositeFieldName"/>!=null)
        {
         <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(org.hibernate.Hibernate.createClob(temp<xsl:value-of select="$compositeFieldName"/>));
        }
      </xsl:if>

    </xsl:for-each>
    <xsl:for-each select="column[not(@name=../foreign-key/reference/@local)]">
      <xsl:variable name="columnNormalName" select="java:getCompositeName($handler,java:getFieldName($handler,@name))"/>
      <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
      <xsl:variable name="columnName" select="@name"/>
      <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
      <xsl:variable name="fieldName">
       <xsl:choose>
         <xsl:when test="$hints/@CutPreffixesAtAttributes='false'"><xsl:value-of select="java:getFieldName($handler,@name,false)"/></xsl:when>
         <xsl:otherwise><xsl:value-of select="java:getFieldName($handler,@name)"/></xsl:otherwise>
       </xsl:choose>
      </xsl:variable>
      <xsl:if test="not($hints/FIELD[@Column=$columnName]/HINT[@Name='NotInFillData' and @Value='true'])">
      <xsl:if test="not(@primaryKey='true') and @required='true' and not(@default)">
      <xsl:choose>
        <xsl:when test="$fieldClass='java.lang.String'"><!-- STRING -->
          if (<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>() == null
            || <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>().trim().length() == 0)
          {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR,
                "<xsl:value-of select="$name"/> has no <xsl:value-of select="$columnNormalName"/>"));
          }
        </xsl:when>
        <xsl:when test="$fieldClass='java.sql.Clob'"><!-- CLOB -->
        try
        {
          if (<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>() == null
            || <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>().length() == 0)
          {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR,
                "<xsl:value-of select="$name"/> has no <xsl:value-of select="$columnNormalName"/>"));
          }
        }
        catch(java.sql.SQLException se)
        {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR,
                "<xsl:value-of select="$name"/> has no <xsl:value-of select="$columnNormalName"/>"));
        }
        </xsl:when>        <!-- INT BYTE LONG DOUBLE BIGDECIMAL-->
        <xsl:when test="$fieldClass='int' or $fieldClass='short' or $fieldClass='byte' or $fieldClass='long' or $fieldClass='double' or $fieldClass='java.math.BigDecimal'">
          if ((String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM) == null
            || ((String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM)).trim().length() == 0)
          {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR,
                "<xsl:value-of select="$name"/> has no <xsl:value-of select="$columnNormalName"/>"));
          }
        </xsl:when>   <!-- DATE or TIMESTAMP -->
        <xsl:when test="$fieldClass='java.sql.Date' or $fieldClass='java.sql.Timestamp'">
          if ((String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM) == null
            || ((String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM)).trim().length() == 0)
          {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_NO_<xsl:value-of select="$fieldName"/>_CREATION_ERROR,
                "<xsl:value-of select="$name"/> has no <xsl:value-of select="$columnNormalName"/>"));
          }
        </xsl:when>
      </xsl:choose>
      </xsl:if>
      <xsl:choose>
        <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='Url']"><!-- URL -->
          if (<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>() != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
              <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>().trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
          {
            try
            {
              new java.net.URL(<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>());
            }
            catch (Exception e)
            {
            errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
            }
          }
        </xsl:when><!-- DATE without Formatter-->
        <xsl:when test="not($hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and (@Value='sql.Date')]) and $fieldClass='java.sql.Date'">
      String tempValue<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
      if (tempValue<xsl:value-of select="$compositeFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
          tempValue<xsl:value-of select="$compositeFieldName"/>.trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
      {
        try
        {
                      java.text.SimpleDateFormat sdf<xsl:value-of select="$compositeFieldName"/> =
          new java.text.SimpleDateFormat("dd/MM/yyyy");
          java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> =
          sdf<xsl:value-of select="$compositeFieldName"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
          java.sql.Date theSQLDate<xsl:value-of select="$compositeFieldName"/> =
          new java.sql.Date(theDate<xsl:value-of select="$compositeFieldName"/>.getTime());
          <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(theSQLDate<xsl:value-of select="$compositeFieldName"/>);
        }
        catch (Exception e)
        {
        errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
      <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
        }
      }
  </xsl:when>
  <!-- TIMESTAMP without Formatter -->
    <xsl:when test="not($hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and (@Value='sql.Timestamp')]) and $fieldClass='java.sql.Timestamp'">
      String tempValue<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
      if (tempValue<xsl:value-of select="$compositeFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
          tempValue<xsl:value-of select="$compositeFieldName"/>.trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
      {
        try
        {
                      java.text.SimpleDateFormat sdf<xsl:value-of select="$compositeFieldName"/> =
          new java.text.SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss Z");
          java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> =
          sdf<xsl:value-of select="$compositeFieldName"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
          java.sql.Timestamp theSQLDate<xsl:value-of select="$compositeFieldName"/> =
          new java.sql.Timestamp(theDate<xsl:value-of select="$compositeFieldName"/>.getTime());
          <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(theSQLDate<xsl:value-of select="$compositeFieldName"/>);
        }
        catch (Exception e)
        {
        errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
      <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
        }
      }
  </xsl:when>
  <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='sql.Timestamp']"><!-- TIMESTAMP with format-->
          String tempValue<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
          if (tempValue<xsl:value-of select="$compositeFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
              tempValue<xsl:value-of select="$compositeFieldName"/>.trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
          {
            try
            {
              <xsl:variable name="format" select="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='sql.Timestamp']/@Formatter"/>
              <xsl:choose>
                <xsl:when test="$format">
                  java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> = <xsl:value-of select="$format"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
                </xsl:when>
                <xsl:otherwise>
                      java.text.SimpleDateFormat sdf<xsl:value-of select="$compositeFieldName"/> =
          new java.text.SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss Z");
          java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> =
          sdf<xsl:value-of select="$compositeFieldName"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
                </xsl:otherwise>
              </xsl:choose>
              java.sql.Timestamp theTS = new java.sql.Timestamp(theDate<xsl:value-of select="$compositeFieldName"/>.getTime());
              <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(theTS);
            }
            catch (Exception e)
            {
            errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
            }
          }
        </xsl:when>
        <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='sql.Date']">
          String tempValue<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
          if (tempValue<xsl:value-of select="$compositeFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
              tempValue<xsl:value-of select="$compositeFieldName"/>.trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
          {
            try
            {
              <xsl:variable name="format" select="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='sql.Date']/@Formatter"/>
              <xsl:choose>
                <xsl:when test="$format">
                  java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> = <xsl:value-of select="$format"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
                </xsl:when>
                <xsl:otherwise>
                      java.text.SimpleDateFormat sdf<xsl:value-of select="$compositeFieldName"/> =
          new java.text.SimpleDateFormat("dd/MM/yyyy");
          java.util.Date theDate<xsl:value-of select="$compositeFieldName"/> =
          sdf<xsl:value-of select="$compositeFieldName"/>.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);
                </xsl:otherwise>
              </xsl:choose>
              java.sql.Date theTS = new java.sql.Date(theDate<xsl:value-of select="$compositeFieldName"/>.getTime());
              <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(theTS);
            }
            catch (Exception e)
            {
            errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
            }
          }
        </xsl:when>
        <xsl:when test="$hints/FIELD[@Column=$columnName]/HINT[@Name='Format' and @Value='Email']">
          if (<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>() != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
              <xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>().trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
          {
            try
            {
              if (<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>().indexOf("@") == -1)
              {
                errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR
                ,"Email address does not even have a '@' character."));
              }
              else
              {
                new javax.mail.internet.InternetAddress(<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>());
              }
            }
            catch (Exception e)
            {
            errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
            }
          }
        </xsl:when>
        <xsl:when test="$fieldClass='int' or $fieldClass='short' or $fieldClass='byte' or $fieldClass='long' or $fieldClass='double' or $fieldClass='java.math.BigDecimal'">
          String tempValue<xsl:value-of select="$compositeFieldName"/> = (String) paramMap.get(<xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_PARAM);
          if (tempValue<xsl:value-of select="$compositeFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text>
              tempValue<xsl:value-of select="$compositeFieldName"/>.trim().length()<xsl:text disable-output-escaping="yes"> &gt; </xsl:text>0)
          {
              try
              {
                java.text.NumberFormat theNF = java.text.NumberFormat.getInstance();
                Number theNumber = theNF.parse(tempValue<xsl:value-of select="$compositeFieldName"/>);			  
                <xsl:choose>
                    <xsl:when test="$fieldClass='int'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(Integer.parseInt(theNumber.toString()));
                    </xsl:when>
                    <xsl:when test="$fieldClass='short'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(Short.parseShort(theNumber.toString()));
                    </xsl:when>
                    <xsl:when test="$fieldClass='byte'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(Byte.parseByte(theNumber.toString()));
                    </xsl:when>
                    <xsl:when test="$fieldClass='long'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(Long.parseLong(theNumber.toString()));
                    </xsl:when>
                    <xsl:when test="$fieldClass='double'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(Double.parseDouble(theNumber.toString()));
                    </xsl:when>
                    <xsl:when test="$fieldClass='java.math.BigDecimal'">
                      <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeFieldName"/>(new java.math.BigDecimal(theNumber.toString()));
                    </xsl:when>
                </xsl:choose>
              }
              catch (Exception e)
              {
              errorListXML.addElement(DefaultXMLSource.getErrorXMLNode(
                  <xsl:value-of select="$upperName"/>_<xsl:value-of select="$fieldName"/>_BAD_FORMAT_CREATION_ERROR,e));
              }
          }
        </xsl:when>
      </xsl:choose>
      </xsl:if>
    </xsl:for-each>
    if (<xsl:value-of select="$lowerName"/>Original != null)
    {
    <xsl:for-each select="column[not(@name=../foreign-key/reference/@local) and not(@primaryKey='true')]">
      <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
      <xsl:variable name="columnName" select="@name"/>
      <xsl:variable name="fieldClass" select="java:getClassNameFromType($handler,@type)"/>
      <xsl:if test="not($hints/FIELD[@Column=$columnName]/HINT[@Name='NotInFillData' and @Value='true'])">
      <xsl:value-of select="$lowerName"/>Original.set<xsl:value-of select="$compositeFieldName"/>(<xsl:value-of select="$lowerName"/>.get<xsl:value-of select="$compositeFieldName"/>());
      </xsl:if>
    </xsl:for-each>
    }
    return <xsl:value-of select="$lowerName"/>;
  }

  /**
  * @return a dummy <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/> filled with the data
  */
  public static void fill<xsl:value-of select="$name"/>RelatedData(
    java.util.Map paramMap,
    XMLNode errorListXML,
    <xsl:value-of select="$beanName"/><xsl:value-of select="$blgSuffix"/><xsl:text> </xsl:text><xsl:value-of select="$lowerName"/>,
    org.hibernate.Session theSession)
  {
     <xsl:variable name="tableName" select="@name" />
   <xsl:for-each select="column[@name=../foreign-key/reference/@local]">
   <!-- Definicion de variables -->
    <xsl:variable name="fieldName" select="java:getNormalName($handler,@name)"/>
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="compositeFieldName" select="java:getCompositeName($handler,@name)"/>
    <xsl:variable name="relatedTableName" select="../foreign-key[reference/@local=$name]/@foreignTable"/>
    <xsl:variable name="relatedFieldName" select="../foreign-key/reference[@local=$name]/@foreign"/>
    <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
    <xsl:variable name="compositeRelatedName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
    <xsl:variable name="lowerCompositeRelatedName" select="java:getLowerCase($handler,$compositeRelatedName)"/>
    <xsl:variable name="upperCompositeRelatedName" select="java:getUpperCase($handler,$compositeRelatedName)"/>
    <xsl:variable name="compositeRelatedTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
    <xsl:variable name="compositeRelatedUtilsName" select="concat(java:getCompositeName($handler,$relatedTableName),$entitySuffix)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
   <!-- Final de definicion de variables -->
   // PENDING needs to be rechecked for multiple relationships <xsl:value-of select="$fieldName"/>, <xsl:value-of select="$compositeRelatedFieldName"/>
    String related<xsl:value-of select="$compositeRelatedFieldName"/><xsl:value-of select="$differenceFieldName"/> =
      (String) paramMap.get(<xsl:value-of select="java:getEntityName($handler,$tableName)"/>_<xsl:value-of select="java:getFieldName($handler,$name)"/>_PARAM);
    if (related<xsl:value-of select="$compositeRelatedFieldName"/><xsl:value-of select="$differenceFieldName"/> != null <xsl:text disable-output-escaping="yes"> &amp;&amp; </xsl:text> related<xsl:value-of select="$compositeRelatedFieldName"/><xsl:value-of select="$differenceFieldName"/>.trim().length() <xsl:text disable-output-escaping="yes"> &gt; </xsl:text> 0)
    {
      try
      {
        <xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/> theReal<xsl:value-of select="$compositeRelatedName"/> =
          (<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/>) theSession.get(<xsl:value-of select="$blgPackage"/><xsl:value-of select="$compositeRelatedTableName"/>.class, related<xsl:value-of select="$compositeRelatedFieldName"/><xsl:value-of select="$differenceFieldName"/>);
        if (theReal<xsl:value-of select="$compositeRelatedName"/> != null)
        {
          <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$differenceFieldName"/>(theReal<xsl:value-of select="$compositeRelatedName"/>);
        }
        else
        {
          errorListXML.addElement(<xsl:value-of select="$compositeRelatedUtilsName"/>.getNo<xsl:value-of select="$compositeRelatedName"/>XML(related<xsl:value-of select="$compositeRelatedFieldName"/><xsl:value-of select="$differenceFieldName"/>));
        }
      }
      catch (org.hibernate.HibernateException e)
      {
        errorListXML.addElement(
          DefaultXMLSource.getErrorXMLNode("Error accesing <xsl:value-of select="$lowerCompositeRelatedName"/>", e));
      }
    }<xsl:if test="@required='true' and not(@default)">
    else
    {
      errorListXML.addElement(
        DefaultXMLSource.getErrorXMLNode(
          RELATED_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="$differenceFieldName"/>_EMPTY_ERROR,
          "<xsl:value-of select="java:getEntityNormalName($handler)"/> has no <xsl:value-of select="$compositeRelatedFieldName"/>"));

    }
    </xsl:if>
   </xsl:for-each>
    /*****************************
    Fill related 1-N and N-M data
    ******************************/
   <xsl:variable name="originalname" select="@name"/>
   <xsl:for-each select="../table/foreign-key[@foreignTable=$originalname]">
     <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
     <xsl:variable name="local" select="reference/@local"/>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
     <xsl:variable name="normalTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
     <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
     <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
     <xsl:variable name="theSuffix">
      <xsl:choose>
        <xsl:when test="$tableName = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
        <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
      </xsl:choose>
     </xsl:variable>
     <xsl:variable name="concatSuffix">
      <xsl:choose>
        <xsl:when test="$theSuffix!=''">_<xsl:value-of select="$theSuffix"/></xsl:when>
      </xsl:choose>
     </xsl:variable>
     <xsl:variable name="paramName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="localFor" select="java:getNormalName($handler,reference/@local)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$localFor,$compositeRelatedFieldName)"
    />
    <xsl:value-of select="concat(java:getCompositeName($handler,../@name),$entitySuffix)"/>.<xsl:value-of select="java:getEntityName($handler,../@name)"/>_<xsl:value-of select="java:getFieldName($handler,reference/@local)"/>_PARAM
     </xsl:when>
     <xsl:otherwise>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
    <xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="java:getUpperCase($handler,$concatSuffix)"/>_PARAM
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
     <xsl:variable name="relEntityName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
    <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="localFor" select="java:getNormalName($handler,reference/@local)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$localFor,$compositeRelatedFieldName)"
    />
     <xsl:value-of select="$compositeTableName"/>
     </xsl:when>
     <xsl:otherwise>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
     <xsl:variable name="compositeRelatedTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
     <xsl:value-of select="$compositeRelatedTableName"/>
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
     <xsl:variable name="varName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
         <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="compositeTableName" select="java:getEntityNormalName($handler,../@name)"/>
     <xsl:variable name="localFor" select="java:getNormalName($handler,reference/@local)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$localFor,$compositeRelatedFieldName)"  />
     <xsl:value-of select="$compositeTableName"/><xsl:value-of select="$differenceFieldName"/>
     </xsl:when>
     <xsl:otherwise>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
     <xsl:variable name="compositeRelatedTableName" select="java:getEntityNormalName($handler,$relatedTableName)"/>
     <xsl:value-of select="$compositeRelatedTableName"/><xsl:value-of select="$theSuffix"/>
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
     <xsl:variable name="varEntityName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
     <xsl:value-of select="$compositeTableName"/>
     </xsl:when>
     <xsl:otherwise>
       <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
       <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
     <xsl:value-of select="$compositeTableName"/>
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
     <xsl:variable name="compositeRelatedUtilsName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
     <xsl:value-of select="concat(java:getCompositeName($handler,../@name),$entitySuffix)"/>
     </xsl:when>
     <xsl:otherwise>
       <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
     <xsl:value-of select="concat(java:getCompositeName($handler,$relatedTableName),$entitySuffix)"/>
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
     <xsl:variable name="getName">
     <xsl:choose>
     <xsl:when test="normalize-space($isNotNM)">
     <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,../@name),$blgSuffix)"/>
     <xsl:variable name="fieldName" select="java:getNormalName($handler,reference/@local)"/>
    <xsl:variable name="relatedFieldName" select="reference/@foreign"/>
     <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,$relatedFieldName)"/>
     <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$fieldName,$compositeRelatedFieldName)"/>
     <xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$differenceFieldName"/>
     </xsl:when>
     <xsl:otherwise>
     <xsl:variable name="local" select="reference/@local"/>
     <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$originalname or (@foreignTable=$originalname and reference/@local!=$local)]/@foreignTable"/>
     <xsl:variable name="compositeTableName" select="concat(java:getCompositeName($handler,$relatedTableName),$blgSuffix)"/>
     <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$originalname and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
     <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$originalname and foreign-key/@foreignTable=$relatedTableName])"/>
     <xsl:variable name="theSuffix">
      <xsl:choose>
        <xsl:when test="$originalname = $relatedTableName"><xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
        <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1"><xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
      </xsl:choose>
     </xsl:variable>
     <xsl:value-of select="$compositeTableName"/>s<xsl:value-of select="$theSuffix"/>
     </xsl:otherwise>
    </xsl:choose>
    </xsl:variable>
    // Relation with <xsl:value-of select="$varName"/>
      String[] related<xsl:value-of select="$varName"/> = null;
      Object related<xsl:value-of select="$varName"/>Object = paramMap.get(<xsl:value-of select="$paramName"/>);
      if (related<xsl:value-of select="$varName"/>Object != null)
      {
        if (related<xsl:value-of select="$varName"/>Object.getClass().isArray())
        {
          related<xsl:value-of select="$varName"/> = (String[]) related<xsl:value-of select="$varName"/>Object;
        }
        else
        {
          related<xsl:value-of select="$varName"/> = new String[1];
          related<xsl:value-of select="$varName"/>[0] = (String) related<xsl:value-of select="$varName"/>Object;
        }
      }
      if (related<xsl:value-of select="$varName"/> != null)
      {
        java.util.Set related<xsl:value-of select="$varName"/>Set = new java.util.HashSet(related<xsl:value-of select="$varName"/>.length);
        for (int i = 0; i <xsl:text disable-output-escaping="yes">&lt;</xsl:text> related<xsl:value-of select="$varName"/>.length; i++)
        {
     if (related<xsl:value-of select="$varName"/>[i].trim().length() <xsl:text disable-output-escaping="yes">&gt;</xsl:text> 0)
   {
          try
          {
            <xsl:value-of select="$blgPackage"/><xsl:value-of select="$varEntityName"/> relatedEntity =
              (<xsl:value-of select="$blgPackage"/><xsl:value-of select="$varEntityName"/>) theSession.get(<xsl:value-of select="$blgPackage"/><xsl:value-of select="$varEntityName"/>.class, related<xsl:value-of select="$varName"/>[i]);
            if (relatedEntity != null)
            {
              related<xsl:value-of select="$varName"/>Set.add(relatedEntity);
            }
            else
            {
              errorListXML.addElement(<xsl:value-of select="$compositeRelatedUtilsName"/>.getNo<xsl:value-of select="$relEntityName"/>XML(related<xsl:value-of select="$varName"/>[i]));
            }
          }
          catch (org.hibernate.HibernateException e)
          {
            errorListXML.addElement(
              DefaultXMLSource.getErrorXMLNode("Error accesing <xsl:value-of select="$varName"/>", e));
          }
   }
        }
        <xsl:value-of select="$lowerName"/>.set<xsl:value-of select="$getName"/>(related<xsl:value-of select="$varName"/>Set);
      }
     </xsl:for-each>
    }
</xsl:template>



</xsl:stylesheet>