<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:persistence="http://java.sun.com/xml/ns/persistence"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java persistence"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output
  omit-xml-declaration="yes"
  method="xml"
  indent="yes"
  media-type="text/plain"
  encoding="iso-8859-1"/>
<xsl:param name="package"/>
<xsl:param name="transaction.type">RESOURCE_LOCAL</xsl:param>
<xsl:param name="persistence.provider"/>
<xsl:param name="persistence.nonjdta"/>
<xsl:param name="persistence.properties"/>
<xsl:param name="persistence.unit"/>
<xsl:param name="configFileName">META-INF/persistence.xml</xsl:param>
<xsl:param name="entitySuffix">Bear</xsl:param>
<xsl:param name="blgSuffix">Bear</xsl:param>
<xsl:param name="blgSubPackage">.jpa</xsl:param>
<xsl:variable name="destPackage" select="concat($package,$blgSubPackage)"/>
<xsl:variable name="destDirectory">
  <xsl:call-template name="do-replace">
    <xsl:with-param name="text" select="$destPackage"/>
    <xsl:with-param name="replace">.</xsl:with-param>
    <xsl:with-param name="by">/</xsl:with-param>
  </xsl:call-template>
</xsl:variable>
<xsl:template match="/">
 <xalan:write select="$configFileName">
  <persistence
    xmlns="http://java.sun.com/xml/ns/persistence"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://java.sun.com/xml/ns/persistence
      http://java.sun.com/xml/ns/persistence/persistence_1_0.xsd"
    version="1.0"
    >
    <persistence-unit name="{$persistence.unit}" transaction-type="{$transaction.type}">
    <xsl:if test="$persistence.provider">
      <provider><xsl:value-of select="$persistence.provider"/></provider>  
    </xsl:if>
    <xsl:if test="$persistence.nonjdta">
      <non-jta-data-source><xsl:value-of select="$persistence.nonjdta"/></non-jta-data-source>  
    </xsl:if>
      <xsl:apply-templates select="database/table" mode="JPAMappings"/>
      <exclude-unlisted-classes/>
    <xsl:if test="$persistence.properties">      
      <properties>
        <xsl:value-of select="$persistence.properties" disable-output-escaping="yes"/>
      </properties>
    </xsl:if>
    </persistence-unit>
  </persistence>
 </xalan:write>
</xsl:template>
<xsl:template match="table" mode="JPAMappings">
  <xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
  <xsl:variable name="beanName" select="java:getBeanName($handler)"/>
  <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
  <xsl:if test="normalize-space($isNotNM) and (not($table_pref) or starts-with(@name,$table_pref))">
    <xsl:element name="class" namespace="http://java.sun.com/xml/ns/persistence"><xsl:value-of select="$destPackage"/>.<xsl:value-of select="concat($beanName,$entitySuffix)"/></xsl:element>
  </xsl:if>
</xsl:template>
</xsl:stylesheet>