<?xml version="1.0" encoding="iso-8859-1"?>
<!-- ***** BEGIN LICENSE BLOCK *****
 * WebLEAF a Light wEb Application Framework to help you develop server side web
 * applications written in Java. Copyright (C) 2000 Universidad de las Islas
 * Baleares(UIB), Cra. Valldemossa, km 7.5 07071 Palma de Mallorca(Illes
 * Balears) Espaa This software is the confidential intellectual property of
 * the UIB; it is copyrighted and licensed, not sold. This program is free
 * software; you can redistribute it and/or modify it under the terms of the GNU
 * Lesser General Public License as published by the Free Software Foundation;
 * either version 2.1 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  - ***** END LICENSE BLOCK ***** -->
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xslt/java"
    xmlns:xalan="org.apache.xalan.xslt.extensions.Redirect"
    extension-element-prefixes="xalan"
    exclude-result-prefixes="java"
>
<xsl:import href="genCommon.xsl"/>
<xsl:output  omit-xml-declaration="no" method="xml" indent="yes" media-type="text/plain" encoding="iso-8859-1"/>
<xsl:param name="destdir"/>
<xsl:template match="/">
  <xsl:apply-templates select="database/table" mode="HibernateBean"/>
  <xsl:variable name="file" select="concat($destdir,'/','includes.xsl')"/>
  <xalan:write select="$file">
  <xsl:element name="xsl:stylesheet">
   <xsl:attribute name="version">1.0</xsl:attribute>
    <xsl:text disable-output-escaping="yes">
    &lt;</xsl:text>!--
    ///////////////////////////////////////////
    ////////////// XSLT INCLUDES //////////////
    ///////////////////////////////////////////
    --<xsl:text disable-output-escaping="yes">&gt;
    </xsl:text>
  <xsl:for-each select="database/table">
    <xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
    <xsl:variable name="tableName" select="@name"/>
    <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
    <xsl:variable name="beanName" select="java:getBeanName($handler)"/>
    <xsl:variable name="hints" select="$hintsDOC/GENERATION_HINTS_LIST/ENTITY[@Table=$tableName]"/>
    <xsl:if test="normalize-space($isNotNM) and $hints/HINT[@Name='GenerateUtil' and @Value='true'] and (not($table_pref) or starts-with(@name,$table_pref))">
      <xsl:element name="xsl:import">
       <xsl:attribute name="href"><xsl:value-of select="$beanName"/>.xsl</xsl:attribute>
      </xsl:element>
    </xsl:if>
  </xsl:for-each>
    <xsl:text disable-output-escaping="yes">
    &lt;</xsl:text>!--
    ///////////////////////////////////////////
    //////////// END XSLT INCLUDES ////////////
    ///////////////////////////////////////////
    --<xsl:text disable-output-escaping="yes">&gt;
    </xsl:text>
  </xsl:element>
  </xalan:write>
</xsl:template>
<xsl:template match="table" mode="HibernateBean">
<xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"/></xsl:variable>
<xsl:variable name="format">d'/'MMMM'/'yyyy</xsl:variable>
<xsl:variable name="formatter" select="java:java.text.SimpleDateFormat.new($format)"/>
<xsl:variable name="date" select="java:java.util.Date.new()"/>
<xsl:variable name="data" select="java:format($formatter, $date)"/>
<xsl:variable name="handler" select="java:org.leaf.util.gen.BusinessLogicBeanNameHandler.new(@name)"/>
<xsl:variable name="tableName" select="@name"/>
<xsl:variable name="beanName" select="java:getBeanName($handler)"/>
<xsl:variable name="file" select="concat($destdir,'/',$beanName,'.xsl')"/>
<xsl:variable name="hints" select="$hintsDOC/GENERATION_HINTS_LIST/ENTITY[@Table=$tableName]"/>
<xsl:if test="normalize-space($isNotNM) and $hints/HINT[@Name='GenerateUtil' and @Value='true'] and (not($table_pref) or starts-with(@name,$table_pref))">
<xalan:write select="$file">
  <xsl:element name="xsl:stylesheet">
   <xsl:attribute name="version">1.0</xsl:attribute>
    <xsl:text disable-output-escaping="yes">
    &lt;</xsl:text>!--
    ///////////////////////////////////////
    ////////////// CONSTANTS //////////////
    ///////////////////////////////////////
    --<xsl:text disable-output-escaping="yes">&gt;
    </xsl:text>

    <xsl:apply-templates select="column[not(@name=../foreign-key/reference/@local)]" mode="DeclareParameterConstants">
     <xsl:with-param name="handler" select="$handler"/>
     <xsl:with-param name="hints" select="$hints"/>
    </xsl:apply-templates>

  <xsl:variable name="name" select="@name"/>

    <xsl:apply-templates select="../table/foreign-key[@foreignTable=$name]" mode="DeclareRelationship1NConstants">
     <xsl:with-param name="handler" select="$handler"/>
     <xsl:with-param name="beanName" select="$beanName"/>
     <xsl:with-param name="tableName" select="@name"/>
    </xsl:apply-templates>

    <xsl:text disable-output-escaping="yes">
    &lt;</xsl:text>!--
    ////////////////////////////////////////////////////////
    //////////// Constants parameters of listOf ////////////
    ////////////////////////////////////////////////////////
    --<xsl:text disable-output-escaping="yes">&gt;
    </xsl:text>
<xsl:variable name="upperTableName" select="java:getEntityName($handler)"/>
<xsl:variable name="lowerTableName" select="java:getLowerCase($handler,$upperTableName)"/>

<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_NUMPAGE</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_numpage</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_NUM_MAXROWS_VIEWED</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_num_maxrows_viewed</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_LIST_ORDER</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_list_order</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_LIST_ORDER_DIR</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_list_order_dir</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_NUM_MAXROWS_VIEWED</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_def_num_maxrows_viewed</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_LIST_ORDER</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_def_list_order</xsl:element>
<xsl:element name="xsl:variable"><xsl:attribute name="name">PARAM_<xsl:value-of select="$upperTableName"/>_DEFAULT_LIST_ORDER_DIR</xsl:attribute>param_<xsl:value-of select="$lowerTableName"/>_def_list_order_dir</xsl:element>

    <xsl:text disable-output-escaping="yes">
    &lt;</xsl:text>!--
    ///////////////////////////////////////
    //////////// END CONSTANTES ////////////
    ///////////////////////////////////////
    --<xsl:text disable-output-escaping="yes">&gt;
    </xsl:text>
  </xsl:element>
</xalan:write>
</xsl:if>
 </xsl:template>

<xsl:template match="column" mode="DeclareParameterConstants">
 <xsl:param name="handler"/>
 <xsl:param name="hints"/>
 <xsl:variable name="fieldName">
  <xsl:choose>
    <xsl:when test="$hints/@CutPreffixesAtAttributes='false'"><xsl:value-of select="java:getFieldName($handler,@name,false)"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="java:getFieldName($handler,@name)"/></xsl:otherwise>
  </xsl:choose>
 </xsl:variable>
  <xsl:element name="xsl:variable">
  <xsl:attribute name="name"><xsl:value-of select="java:getEntityName($handler)"/>_<xsl:value-of select="$fieldName"/>_PARAM</xsl:attribute>
  <xsl:value-of select="java:getLowerCase($handler,@name)"/>
  </xsl:element>
</xsl:template>

<xsl:template match="foreign-key" mode="DeclareRelationship1NConstants">
 <xsl:param name="handler"/>
 <xsl:param name="beanName"/>
 <xsl:param name="tableName"/>
 <xsl:variable name="isNotNM"><xsl:call-template name="checkTableNM"><xsl:with-param name="table" select=".."/></xsl:call-template></xsl:variable>
 <xsl:variable name="local" select="reference/@local"/>
 <xsl:choose>
 <xsl:when test="normalize-space($isNotNM)">
<xsl:variable name="localNormal" select="java:getNormalName($handler,$local )"/>
 <xsl:variable name="compositeRelatedFieldName" select="java:getCompositeName($handler,reference/@foreign)"/>
 <xsl:variable name="differenceFieldName" select="java:getDifferenceInName($handler,$localNormal,$compositeRelatedFieldName)"/>
  <xsl:element name="xsl:variable">
  <xsl:attribute name="name"><xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,../@name)"/><xsl:value-of select="java:getUpperCase($handler,$differenceFieldName)"/>_PARAM</xsl:attribute>
  <xsl:value-of select="java:getLowerCase($handler,reference/@local)"/>
  </xsl:element>
 </xsl:when>
 <xsl:otherwise>
 <xsl:variable name="relatedTableName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/@foreignTable"/>
   <xsl:variable name="relatedFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@local"/>
   <xsl:variable name="relatedOtherFieldName" select="../foreign-key[@foreignTable=$tableName and reference/@local=$local]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherFieldName" select="java:getNormalName($handler,$relatedOtherFieldName)"/>
   <xsl:variable name="relatedForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@local"/>
   <xsl:variable name="relatedOtherForeignFieldName" select="../foreign-key[@foreignTable!=$tableName or (@foreignTable=$tableName and reference/@local!=$local)]/reference/@foreign"/>
   <xsl:variable name="normalRelatedOtherForeignFieldName" select="java:getNormalName($handler,$relatedOtherForeignFieldName)"/>
   <xsl:variable name="tablasRelacionadasNoNM" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName][not(column/@primaryKey='true')])"/>
   <xsl:variable name="tablasRelacionadas" select="count(../../table[foreign-key/@foreignTable=$tableName and foreign-key/@foreignTable=$relatedTableName])"/>
   <xsl:variable name="theSuffix">
    <xsl:choose>
      <xsl:when test="$tableName = $relatedTableName">_<xsl:value-of select="java:getSuffix($handler,$local)"/></xsl:when>
      <xsl:when test="$tablasRelacionadas - $tablasRelacionadasNoNM > 1">_<xsl:value-of select="java:getSuffix($handler,../@name)"/></xsl:when>
    </xsl:choose>
   </xsl:variable>
 <xsl:element name="xsl:variable">
  <xsl:attribute name="name"><xsl:value-of select="java:getEntityName($handler)"/>_FK_<xsl:value-of select="java:getEntityName($handler,$relatedTableName)"/><xsl:value-of select="java:getUpperCase($handler,$theSuffix)"/>_PARAM</xsl:attribute>
  <xsl:value-of select="concat('fk_',java:getLowerCase($handler,java:getEntityName($handler)))"/>_<xsl:value-of select="java:getLowerCase($handler,java:getEntityName($handler,$relatedTableName))"/>  </xsl:element>
 </xsl:otherwise>
</xsl:choose>
</xsl:template>
</xsl:stylesheet>